using NLsolve
using Optim
function partitionTrain(Tftstot,Tlabelstot,at)
        nm=size(Tftstot,1);
        idx=shuffle(1:nm);
        #idx=[i for i=1:nm];
        train_idx=view(idx,1:floor(Int,at*nm))
        test_idx=view(idx,floor(Int,at*nm)+1:nm)
        Tfts=Tftstot[train_idx,:]';
        Tlabels=Tlabelstot[train_idx,:];
        X_test1=Tftstot[test_idx,:]';
        y_test1=Tlabelstot[test_idx,:];
        return Tfts,Tlabels,X_test1,y_test1
end
function generate_statistic(k,m,p,β)
    #Random generation of M
    M=zeros(p,k*m)
    # for i=1:k
    #     for j=1:m
    #             #Random.seed!(m*(i-1)+j);
    #             M[:,m*(i-1)+j]=0.2*randn(p,1);
    #     end
    # end
    # fileD=matopen("/Users/tiomokomalik/Downloads/JMLR_code/M.mat")
    # M=read(fileD,"M");
    #Deterministic genration of M
    M[:,1]=2*[1;0;0;0;zeros(p-4,1)];
    M[:,2]=2*[-1;0;0;0;zeros(p-4,1)];
    μ_orth=2*[0;1;0;0;zeros(p-4,1)];
    μ_orth2=2*[0;-1;0;0;zeros(p-4,1)];
    M[:,3]=β*M[:,1]+sqrt(1-β^2)*μ_orth;
    M[:,4]=β*M[:,2]+sqrt(1-β^2)*μ_orth2;
    #α=abs.(rand(m*k,1));
    α=zeros(m*k,1);
    Σ=zeros(p,p,m*k);
    for i=1:k
        for j=1:m
            Σ[:,:,m*(i-1)+j]=Toeplitz(α[m*(i-1)+j].^(0:p-1),α[m*(i-1)+j].^(0:p-1));
        end
    end
    return M,Σ
end

function generate_data(p,ns,k,m,β,M,Σ,data_type,n_test)
    i=1;
    Sfts=reduce(hcat, [M[:,m*(i-1)+j]*ones(1,ns[m*(i-1)+j])+Σ[:,:,m*(i-1)+j]*randn(p,ns[m*(i-1)+j]) for j=1:m]);
    Slabels=[ones(ns[m*(i-1)+1],1);-ones(ns[m*(i-1)+2],1)];
    Tfts=reduce(hcat, [M[:,m*(k-1)+j]*ones(1,ns[m*(k-1)+j])+Σ[:,:,m*(k-1)+j]*randn(p,ns[m*(k-1)+j]) for j=1:m]);
    Tlabels=[ones(ns[m*(k-1)+1],1);-ones(ns[m*(k-1)+2],1)];
    X_test=reduce(hcat, [M[:,m*(1-1)+j]*ones(1,n_test[m*(1-1)+j])+Σ[:,:,m*(1-1)+j]*randn(p,n_test[m*(1-1)+j]) for j=1:m]);
    y_test=[ones(n_test[m*(1-1)+1],1);-ones(n_test[m*(1-1)+2],1)];
    X_test1=reduce(hcat, [M[:,m*(2-1)+j]*ones(1,n_test[m*(2-1)+j])+Σ[:,:,m*(2-1)+j]*randn(p,n_test[m*(2-1)+j]) for j=1:m]);
    y_test1=[ones(n_test[m*(2-1)+1],1);-ones(n_test[m*(2-1)+2],1)];
    return Sfts,Slabels,Tfts,Tlabels,X_test,y_test,X_test1,y_test1
end
function RMTMTLLSSVM_real(Sfts,Slabels,Tfts,Tlabels,λ,γ,X_test,X_test1,ns,tl)
        #Define parameters
        p,nul=size(Tfts);
        #y_test=[ones(n_test[1],1);-ones(n_test[2],1)];
        #y_test1=[ones(n_test[3],1);-ones(n_test[4],1)];
        #k=numel(X1)+1;
        k=2;
        m=2
        n=sum(ns);
        c=ns/sum(ns);
        co=k*p/n;
        n1=sum(ns[1:2]);n2=sum(ns[3:4]);
        P=zeros(n,k);
        P[1:n1,1]=ones(n1,1);P[n1+1:end,2]=ones(n2,1);
        A=kron(diagm(γ)+λ*ones(k,1)*ones(1,k),Matrix{Float64}(I, p, p));
        #Compute statististics of the data.
        #Centering and scaling of the data;
        Mi,Σi=compute_statistics(Sfts,Tfts,ns);
        Sfts_c=(Sfts*(Matrix{Float64}(I, n1, n1)-(1/n1)*ones(n1,1)*ones(1,n1)));
        Sfts_cs=Sfts_c./((1/(n1*p))*tr(Sfts_c*Sfts_c'));
        Tfts_c=(Tfts*(Matrix{Float64}(I, n2, n2)-(1/n2)*ones(n2,1)*ones(1,n2)));
        Tfts_cs=Tfts_c./((1/(n2*p))*tr(Tfts_c*Tfts_c'));
        M,Σ=compute_statistics(Sfts_cs,Tfts_cs,ns);
        # M_c_pop_s=sum((ns[j]./n1)*Mo[:,j] for j=1:m)
        # M_c_pop_t=sum((ns[m+j]./n2)*Mo[:,m+j] for j=1:m)
        # M_source_c=Mo[:,1:2]-M_c_pop_s*ones(1,2);
        # M_target_c=Mo[:,3:4]-M_c_pop_t*ones(1,2);
        # M_source_cs=(Mo[:,1:2]-M_c_pop_s*ones(1,2))/((1/(n1*p))*tr(Sfts_c*Sfts_c'));
        # M_target_cs=(Mo[:,3:4]-M_c_pop_t*ones(1,2))/((1/(n2*p))*tr(Tfts_c*Tfts_c'));
        # M=[M_source_cs M_target_cs];
        # M_source=(Mo[:,1]-Mo[:,2])/((1/(n1*p))*tr(Sfts_c*Sfts_c'));
        # M_target=(Mo[:,3]-Mo[:,4])/((1/(n2*p))*tr(Tfts_c*Tfts_c'));
        Σ[:,:,1]=Matrix{Float64}(I, p, p);
        Σ[:,:,2]=Matrix{Float64}(I, p, p);
        Σ[:,:,3]=Matrix{Float64}(I, p, p);
        Σ[:,:,4]=Matrix{Float64}(I, p, p);
        M_cens=sum((ns[j]./n1)*Mi[:,j] for j=1:m)
        X_test=(X_test-M_cens*ones(1,size(X_test)[2]))./((1/(n1*p))*tr(Sfts_c*Sfts_c'));
        M_cent=sum((ns[m*(k-1)+j]./n2)*Mi[:,m*(k-1)+j] for j=1:m)
        X_test1=(X_test1-M_cent*ones(1,size(X_test1)[2]))./((1/(n2*p))*tr(Tfts_c*Tfts_c'));
        Z=[Sfts_cs zeros(p,n2);zeros(p,n1) Tfts_cs];
        Q=inv((1/(k*p))*Z'*A*Z+Matrix{Float64}(I, n, n));
        y=[Slabels;Tlabels];
        b=(P'*Q*P)\(P'*Q*y);
        # M0=zeros(k*p,m*k);
        # for i=1:k
        #         e_i=zeros(k,1);e_i[i]=1;
        #         for j=1:m
        #                 M0[:,m*(i-1)+j]=kron(e_i,M[:,m*(i-1)+j]);
        #         end
        # end
        e_s=zeros(k,1);e_t=zeros(k,1);
        e_s[1]=1;e_t[2]=1;
        gx_s=(1/(k*p))*kron(e_s,X_test)'*A*Z*Q*(y-P*b)+b[1]*ones(size(X_test)[2],1);
        gx_t=(1/(k*p))*kron(e_t,X_test1)'*A*Z*Q*(y-P*b)+b[2]*ones(size(X_test1)[2],1);
        # gx_t2=(1/(k*p))*kron(e_t,X_test1)'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y-P*b)+b[2]*ones(sum(n_test[3:4]),1);
        # gx_t22=(1/(k*p))*kron(e_t,X_test1)'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y-P*b)+b[2]*ones(sum(n_test[3:4]),1);
        # gx_t222=(1/(k*p))*M0[:,3:4]'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y-P*b)+[b[2];b[2]];
        #gx_s2=(1/(k*p))*M0[:,1:2]'*A*Z*Q*(y-P*b)+[b[1];b[1]];
        #gx_t2=(1/(k*p))*M0[:,3:4]'*A*Z*Q*(y-P*b)+[b[2];b[2]];
        μ_emp=zeros(m*k,1);
        σ_emp=zeros(m*k,1);
        σ_th=zeros(k,1);
        # μ_emp[1]=mean(gx_s[1:n_test[1]]);
        # μ_emp[2]=mean(gx_s[1+n_test[1]:n_test[1]+n_test[2]]);
        # μ_emp[3]=mean(gx_t[1:n_test[3]]);
        # μ_emp[4]=mean(gx_t[n_test[3]+1:n_test[3]+n_test[4]]);
        # σ_emp[1]=std(gx_s[1:n_test[1]]).^2;
        # σ_emp[2]=std(gx_s[1+n_test[1]:n_test[1]+n_test[2]]).^2;
        # σ_emp[3]=std(gx_t[1:n_test[3]]).^2;
        # σ_emp[4]=std(gx_t[n_test[3]+1:end]).^2;
        #Calcul covariance généralisé
        C=zeros(k*p,k*p,m*k);
        for i=1:k
                e_i=zeros(k,1);e_i[i]=1;
                for j=1:m
                        C[:,:,m*(i-1)+j]=A^(1/2)*kron(e_i*e_i',Σ[:,:,m*(i-1)+j]+M[:,m*(i-1)+j]*M[:,m*(i-1)+j]')*A^(1/2);
                end
        end
        #Calcul du delta
        #δ,Qbar=delta_function(C,k,m,p,ns);
        # δe,Qbar=delta_function(C,k,m,p,ns);
        # M0=zeros(k*p,m*k);
        # for i=1:k
        #         e_i=zeros(k,1);e_i[i]=1;
        #         for j=1:m
        #                 M0[:,m*(i-1)+j]=kron(e_i,M[:,m*(i-1)+j]);
        #         end
        # end
        # M_δ=M0*diagm(vec(ones(m*k,1)./(ones(m*k,1)+δe)));
        # Mg=A^(1/2)*M0*diagm(sqrt.(vec(c./(co*(ones(m*k,1)+δe)))));
        # invQtilde0=zeros(k*p,k*p);
        # for i=1:k
        #         e_i=zeros(k,1);e_i[i]=1;
        #         for j=1:m
        #                 global invQtilde0=invQtilde0+kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i*e_i'*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2),(c[m*(i-1)+j]./(co*(1+δe[m*(i-1)+j])))*Σ[:,:,m*(i-1)+j]);
        #         end
        # end
        # Qtilde0=inv(invQtilde0+Matrix{Float64}(I, k*p, k*p));
        δ=delta_function_identity(C,k,m,p,ns,λ,γ);
        cb=zeros(2,k);
        for i=1:k
                cb[:,i]=sqrt(c[m*(i-1)+1]./(sum(c[m*(i-1)+1:m*(i-1)+2])))*sqrt(c[m*(i-1)+2]./(sum(c[m*(i-1)+1:m*(i-1)+2])))*
                [sqrt(c[m*(i-1)+2]./(sum(c[m*(i-1)+1:m*(i-1)+2])));-sqrt(c[m*(i-1)+1]./(sum(c[m*(i-1)+1:m*(i-1)+2])))];
        end
        J=zeros(n,m*k);
         J[1:ns[1],1]=ones(ns[1],1);J[ns[1]+1:ns[1]+ns[2],2]=ones(ns[2],1);J[n1+1:n1+ns[3],3]=ones(ns[3],1);J[n1+ns[3]+1:end,4]=ones(ns[4],1);
        e_i=Matrix{Float64}(I, k, k);
        # J11=zeros(n1,1);J12=zeros(n1,1);
        # J21=zeros(n2,1);J22=zeros(n2,1);
        # J11[1:ns[1],:]=ones(ns[1],1);J12[ns[1]+1:end,:]=ones(ns[2],1);
        # J21[1:ns[3],:]=ones(ns[3],1);J22[ns[3]+1:end,:]=ones(ns[4],1);
        # cardS11=ns[1];cardS12=ns[2];cardS21=ns[3];cardS22=ns[4];
        Δμ=zeros(k,k);
        nd=[n1;n2];
        cardS11=convert(Int,floor(ns[2*(1-1)+1]/2));cardS1p1=convert(Int,ns[2*(1-1)+1]-cardS11);cardS12=convert.(Int,floor(ns[2*(1-1)+2]/2));cardS1p2=convert.(Int,ns[2*(1-1)+2]-cardS12);
        cardS21=convert.(Int,floor(ns[2*(2-1)+1]/2));cardS2p1=convert.(Int,ns[2*(2-1)+1]-cardS21);cardS22=convert.(Int,floor(ns[2*(2-1)+2]/2));cardS2p2=convert.(Int,ns[2*(2-1)+2]-cardS22);
        J_11=zeros(nd[1],1);J_12=zeros(nd[1],1);J_1p1=zeros(nd[1],1);J_1p2=zeros(nd[1],1);
        J_21=zeros(nd[2],1);J_22=zeros(nd[2],1);J_2p1=zeros(nd[2],1);J_2p2=zeros(nd[2],1);
        J_11[1:cardS11].=1;J_1p1[cardS11+1:ns[2*(1-1)+1]].=1;J_12[ns[2*(1-1)+1]+1:ns[2*(1-1)+1]+cardS12].=1;
        J_21[1:cardS21].=1;J_2p1[cardS21+1:ns[2*(2-1)+1]].=1;J_22[ns[2*(2-1)+1]+1:ns[2*(2-1)+1]+cardS22].=1;
        J_1p2[ns[2*(1-1)+1]+cardS12+1:end].=1;
        J_2p2[ns[2*(2-1)+1]+cardS22+1:end].=1;
        Δμ[1,1]=((J_11./cardS11-J_12./cardS12)'*Sfts_cs'*Sfts_cs*(J_1p1./cardS1p1-J_1p2./cardS1p2))[1];
        Δμ[2,2]=((J_21./cardS21-J_22./cardS22)'*Tfts_cs'*Tfts_cs*(J_2p1./cardS2p1-J_2p2./cardS2p2))[1];
        cardS11=ns[2*(1-1)+1];cardS12=ns[2*(1-1)+2];cardS21=ns[2*(2-1)+1];cardS22=ns[2*(2-1)+2];
        J_11=zeros(nd[1],1);J_12=zeros(nd[1],1);J_21=zeros(nd[2],1);J_22=zeros(nd[2],1);
        J_11[1:cardS11].=1;J_21[1:cardS21].=1;J_12[cardS11+1:end].=1;J_22[cardS21+1:end].=1;
        Δμ[1,2]=((J_11./cardS11-J_12./cardS12)'*Sfts_cs'*Tfts_cs*(J_21./cardS21-J_22./cardS22))[1];
        Δμ[2,1]=((J_21./cardS21-J_22./cardS22)'*Tfts_cs'*Sfts_cs*(J_11./cardS11-J_12./cardS12))[1];
        #####Test estimation équivalent déterministe
        # Δμ2=zeros(k,k);
        # Δμ2[1,1]=M_source'*M_source;Δμ2[1,2]=M_source'*M_target;Δμ2[2,1]=M_target'*M_source;
        # Δμ2[2,2]=M_target'*M_target;
        #Δμ=Δμ2;

        # Δ=zeros(p,2)
        # Δ[:,1]=(Sfts_cs*(J11./cardS11-J12./cardS12));
        # Δ[:,2]=(Tfts_cs*(J21./cardS21-J22./cardS22));
        # Δ[:,1]=(Mo[:,1]-Mo[:,2])./((1/(n1*p))*tr(Sfts_c*Sfts_c'));
        # Δ[:,2]=(Mo[:,3]-Mo[:,4])./((1/(n2*p))*tr(Tfts_c*Tfts_c'));
        e_j=Matrix{Float64}(I, k*m, k*m);
        c11=c[2*(1-1)+1];c12=c[2*(1-1)+2];c21=c[2*(2-1)+1];c22=c[2*(2-1)+2];
        c1=c11+c12;c2=c21+c22;
        cc=[c1;c2];
        δ_tilde1=zeros(k,1);
        δ_tilde1[1]=c1/(co*(1+δ[1]));δ_tilde1[2]=c2/(co*(1+δ[2]));
        δ_tilde=c./(co*(ones(m*k,1)+kron(δ,ones(m,1))));
        h=[(1/sqrt(δ_tilde1[i]))*(1/cc[i])*sqrt(c[m*(i-1)+1]*c[m*(i-1)+2]./(co*(1+δ[i])))*(sqrt(c[m*(i-1)+2])*e_j[:,m*(i-1)+1]-
        sqrt(c[m*(i-1)+1])*e_j[:,m*(i-1)+2]) for i=1:k];
        #Mg2=sum(kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,i]*e_ij[:,m*(i-1)+j]',sqrt(δ_tilde[m*(i-1)+j])*M[:,m*(i-1)+j]) for i=1:k,j=1:m)
        # Md=[M_source M_target];
        # Mg_t=sum(kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,i]*h[i]',Md[:,i]) for i=1:k)
        Agotique=inv(Matrix{Float64}(I, k, k)+diagm(vec(δ_tilde1))^(-1/2)*inv((diagm(γ)+λ*ones(k,1)*ones(1,k)))*diagm(vec(δ_tilde1))^(-1/2))
        MM=sum(Δμ[i,j]*h[i]*h[j]' for i=1:k,j=1:k);
        Γ=inv(Matrix{Float64}(I, m*k, m*k)+kron(Agotique,ones(k,1)*ones(1,k)).*MM);
        #yo=[1-b[1];-1-b[1];1-b[2];-1-b[2]];
        #gx_s1=(1/(k*p))*kron(e_s,X_test)'*A*Z*Q*(y-P*b)+b[1]*ones(sum(n_test[1:2]),1);
        Ygotique=[1;-1;1;-1];Ygotique0=[1-b[1];-1-b[1];1-b[2];-1-b[2]];
        # (e_ij[:,3]-e_ij[:,4])'*(Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2))*Ygotique
        # (x'*(Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(1/2)*Γ*diagm(vec(δ_tilde))^(-1/2))*(e_ij[:,3]-e_ij[:,4]))
        μ_th=Ygotique-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2)*Ygotique0;
        Dt=diagm(vec([cc[i]./(co*(1+δ[i])^2) for i=1:k]));
        test2=(1/k)*(diagm(vec(δ_tilde1))^(-1/2)*Agotique*diagm(vec(δ_tilde1))^(-1/2)).*(diagm(vec(δ_tilde1))^(-1/2)*Agotique*diagm(vec(δ_tilde1))^(-1/2))
        K=Dt*test2/(Matrix{Float64}(I, k, k)-Dt*test2)
        #KAPPA=diagm(vec(δ_tilde1))^(-1)*K;
        KAPPA=K*diagm(vec(δ_tilde1));
        LUM_test=(test2/(Matrix{Float64}(I, k, k)-Dt*test2))*Dt
        LUM3=sum(LUM_test,dims=2);
        #κ=K*diagm(vec(δ_tilde1))^(-1);
        κ= transpose((co)*diagm(vec(cc))^(-1)*diagm(vec(δ_tilde1))*test2/(Matrix{Float64}(I, k, k)-Dt*test2))
        V=zeros(k*m,k*m,k);
        σ_th=zeros(k,1);
        for i=1:k
                V[:,:,i]=diagm(vec(kron(κ[i,:],ones(k,1))))+kron(Agotique*((1/δ_tilde1[i])*diagm(vec(e_i[:,i]*(1+LUM3[i]))))*Agotique,ones(k,1)*ones(1,k)).*MM;
                σ_th[i]=Ygotique0'*diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,i]*Γ)*diagm(vec(δ_tilde))^(1/2)*Ygotique0;
        end
        ##################TO DELET###################################
        #############################################
        #Calcul de l'erreur empirique et théorique
        # pred_source=zeros(size(X_test)[2],1);pred_target=zeros(size(X_test1)[2],1);
        # threshold_emp=(mean(gx_s[1:n_test[1]])+mean(gx_s[1+n_test[1]:end]))/2;
        # pred_source[gx_s.<threshold_emp*ones(size(X_test)[2],1)].=-1;pred_source[gx_s.>threshold_emp*ones(size(X_test)[2],1)].=1;
        # threshold_emp_target=(mean(gx_t[1:n_test[3]])+mean(gx_t[1+n_test[3]:end]))/2;
        # pred_target[gx_t.<threshold_emp_target*ones(sum(n_test[3:4]),1)].=-1;pred_target[gx_t.>threshold_emp_target*ones(sum(n_test[3:4]),1)].=1;
        # error_source_emp=sum(pred_source.!=y_test)./size(X_test)[2];
        # error_target_emp=sum(pred_target.!=y_test1)./sum(n_test[3:4]);
        # error_source_th=(n_test[1]/size(X_test)[2])*0.5*erfc((μ_th[1]-μ_th[2])./(2*sqrt(2)*sqrt(σ_th[1])))+(n_test[2]/size(X_test)[2])*0.5*erfc((μ_th[1]-μ_th[2])./(2*sqrt(2)*sqrt(σ_th[1])));
        # error_target_th=(n_test[3]/sum(n_test[3:4]))*0.5*erfc((μ_th[3]-μ_th[4])./(2*sqrt(2)*sqrt(σ_th[2])))+(n_test[4]/sum(n_test[3:4]))*0.5*erfc((μ_th[3]-μ_th[4])./(2*sqrt(2)*sqrt(σ_th[2])));
        # A faire l'optimization par rapport à y.
        e_ij=Matrix{Float64}(I, k*m, k*m);
        Ze=zeros(m*k,m*k);task=1;
        rg_k=1+m*(task-1):2+m*(task-1);
        Ze[rg_k,rg_k]=[(1-ns[m*(task-1)+1]/n1) -ns[m*(task-1)+2]/n1;-ns[m*(task-1)+1]/n1 (1-ns[m*(task-1)+2]/n1)];
        rg_t=1+m*(k-1):2+m*(k-1);
        Ze[rg_t,rg_t]=[(1-ns[m*(k-1)+1]/n2) -ns[m*(k-1)+2]/n2; (-ns[m*(k-1)+1]/n2) (1-ns[m*(k-1)+2]/n2)];
        #y_tilde_opt0=diagm(vec(δ_tilde))^(-1/2)*inv(Γ)*inv(V[:,:,2])*(kron(Agotique,ones(k,1)*ones(1,k)).*MM)*diagm(vec(δ_tilde))^(-1/2)*(e_ij[:,3]-e_ij[:,4]);
        # res = optimize(x->(-(x'*(Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2))*(e_ij[:,3]-e_ij[:,4]))^2/
        # (8*x'*diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,2]*Γ)*diagm(vec(δ_tilde))^(1/2)*x)), Ze*[1.0;-1.0;1.0;-1.0])
        #y_tilde_opt0=Optim.minimizer(res);
        y_tilde_opt0=inv(diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,2]*Γ)*diagm(vec(δ_tilde))^(1/2))*
        (Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(1/2)*Γ*diagm(vec(δ_tilde))^(-1/2))*(e_ij[:,3]-e_ij[:,4])
        # x1=Ze*[1.0;-1.0;1.0;-1.0];
        # x2=y_tilde_opt0;
        # y_tilde_opt02=diagm(vec(δ_tilde))^(-1/2)*(inv(Γ)*inv(V[:,:,2])*inv(Γ))*diagm(vec(δ_tilde))^(-1/2)*
        # (Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2))*(e_ij[:,3]-e_ij[:,4])
        # err2=0.5*erfc(sqrt(-res(y_tilde_opt01)));
        # err=0.5*erfc(sqrt(-Optim.minimum(res)));
        y_tilde_opt=pinv(Ze)*y_tilde_opt0;
        #y_tilde_opt=Ze\y_tilde_opt0;
        y_tilde_opt0=Ze*y_tilde_opt;
        # optim1=(x1'*(Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2))*(e_ij[:,3]-e_ij[:,4]))^2/(8*x1'*diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,2]*Γ)*diagm(vec(δ_tilde))^(1/2)*x1)
        # optim2=(x2'*(Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2))*(e_ij[:,3]-e_ij[:,4]))^2/(8*x2'*diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,2]*Γ)*diagm(vec(δ_tilde))^(1/2)*x2)
        #y_tilde_opt=pinv(Ze,rtol=1e-12)*y_tilde_opt0;

        #Calcul empirique
        ez=zeros(k*m,1);ez[m+2]=1;er=[0;1];
        #meanf!(sol)=(((y_tilde_opt+kron(er,sol*ones(m,1)))-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2)*Ze*(y_tilde_opt+kron(er,sol*ones(m,1))))'*ez)[1];
        function meanfg!(sol)
                return (((y_tilde_opt+kron(er,sol*ones(m,1)))-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2)*Ze*(y_tilde_opt+kron(er,sol*ones(m,1))))'*ez)[1]
        end
        asolve=nlsolve(n_ary(meanfg!),[1.0]);
        y_tilde_opt=y_tilde_opt+kron(er,asolve.zero[1]*ones(m,1));
        y_opt=J*y_tilde_opt;
        ##################################
        # S1=zeros(k*p,k*p,m*k);
        # d=zeros(k*m,1);
        # Tbar=zeros(m*k,m*k);
        # Tg=zeros(m*k,m*k);
        # σ_th1=zeros(m*k,1);
        # for i=1:k
        #         e_i=zeros(k,1);e_i[i]=1;
        #         for j=1:m
        #                 S1[:,:,m*(i-1)+j]=kron(e_i*e_i',Σ[:,:,m*(i-1)+j]);
        #                 d[m*(i-1)+j]=ns[m*(i-1)+j]./(k*p*(1+δe[m*(i-1)+j])^2)
        #                 for ip=1:k
        #                         for jp=1:m
        #                                 Tbar[m*(i-1)+j,m*(ip-1)+jp]=(1/(k*p))*tr(C[:,:,m*(ip-1)+jp]*Qbar*A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2)*Qbar);
        #                                 Tg[m*(i-1)+j,m*(ip-1)+jp]=(1/(k*p))*tr(C[:,:,m*(i-1)+j]*Qbar*C[:,:,m*(ip-1)+jp]*Qbar);
        #                         end
        #                 end
        #         end
        # end
        # D=diagm(vec(d));
        # T=Tbar/(Matrix{Float64}(I, m*k, m*k)-D*Tg);
        # κ4=zeros(k*m,k*m);
        # V=zeros(k*p,k*p,m*k);
        # for i=1:k
        #         for j=1:m
        #                 for ip=1:k
        #                         for jp=1:m
        #                                 κ4[m*(i-1)+j,m*(ip-1)+jp]=d[m*(ip-1)+jp]*T[m*(i-1)+j,m*(ip-1)+jp]/δ_tilde[m*(ip-1)+jp];
        #                         end
        #                 end
        #                 LUM=(Tbar/(Matrix{Float64}(I, m*k, m*k)-D*Tg))*D;
        #                 LUM_test=(test2/(Matrix{Float64}(I, k, k)-Dt*test2))*Dt
        #                 LUM2=[LUM[1,1]+LUM[1,2] LUM[1,3]+LUM[1,4];LUM[3,1]+LUM[3,2] LUM[3,3]+LUM[3,4]];
        #                 LUM3=[LUM2[1,1]+LUM2[1,2];LUM2[2,1]+LUM2[2,2]];
        #                 Sec=sum(δ_tilde[m*(ip-1)+jp]*κ4[m*(i-1)+j,m*(ip-1)+jp]*A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2) for ip=1:k,jp=1:m);
        #                 Sec2=LUM3[i]*A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2);
        #                 Ve=kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*(e_i[:,i]*e_i[:,i]'+e_i[:,i]*e_i[:,i]'*LUM3[i])*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2),Matrix{Float64}(I, p, p))
        #                 V[:,:,m*(i-1)+j]=A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2)+Sec;
        #                 σ_th1[m*(i-1)+j]=y_tilde_opt0'*diagm(vec(δ_tilde))^(1/2)*(Γ*diagm(vec(κ4[m*(i-1)+j,:]))*Γ+Γ*Mg'*Qtilde0*V[:,:,m*(i-1)+j]*Qtilde0*Mg*Γ)*diagm(vec(δ_tilde))^(1/2)*y_tilde_opt0;
        #                 Mg2=sum(kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,i]*h[i]'*sqrt(δ_tilde1[i]),Δ[:,i]) for i=1:k)
        #                 Qtilde01=kron(inv(Matrix{Float64}(I, k, k)+(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*diagm(vec(δ_tilde1))*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)),Matrix{Float64}(I, p, p))
        #                 test=Mg'*Qtilde0*V[:,:,m*(i-1)+j]*Qtilde0*Mg
        #                 KAPPAf=Dt*test2/(Matrix{Float64}(I, k, k)-Dt*test2)
        #                 test1=sum(kron(sqrt(δ_tilde1[ip])*h[ip]*e_i[:,ip]'*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*inv(Matrix{Float64}(I, k, k)+(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*diagm(vec(δ_tilde1))*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2))*
        #                 (diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*(e_i[:,i]*e_i[:,i]'+LUM3[i]*e_i[:,i]*e_i[:,i]')*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*inv(Matrix{Float64}(I, k, k)+(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*diagm(vec(δ_tilde1))*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2))*
        #                 (diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,jp]*h[jp]'*sqrt(δ_tilde1[jp]),Δ[:,ip]'*Δ[:,jp]) for ip=1:k,jp=1:k)
        #         end
        # end
        #######################
        b_opt=(P'*Q*P)\(P'*Q*y_opt);
        gx_s_opt=(1/(k*p))*kron(e_s,X_test)'*A*Z*Q*(y_opt-P*b_opt)+b_opt[1]*ones(size(X_test)[2],1);
        gx_t_opt=(1/(k*p))*kron(e_t,X_test1)'*A*Z*Q*(y_opt-P*b_opt)+b_opt[2]*ones(size(X_test1)[2],1);
        # gx_t_opt2=(1/(k*p))*kron(e_t,X_test1)'*A^(1/2)*Qtilde*A^(1/2)*Z*(y_opt-P*b_opt)+b_opt[2]*ones(sum(n_test[3:4]),1);
        # Qtilde=inv((1/(k*p))*A^(1/2)*Z*Z'*A^(1/2)+Matrix{Float64}(I, k*p, k*p));
        #  gx_t2_opt=(1/(k*p))*kron(e_t,X_test1)'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)+b_opt[2]*ones(sum(n_test[3:4]),1);
        #  gx_t22_opt=(1/(k*p))*kron(e_t,X_test1)'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)+b_opt[2]*ones(sum(n_test[3:4]),1);
        #  gx_t2221_opt=(1/(k*p))*kron(e_t,mean(X_test1[:,1:n_test[1]],dims=2))'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)+[b_opt[2]];
        #  gx_t222_opt=(1/(k*p))*M0'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)+[b_opt[1];b_opt[1];b_opt[2];b_opt[2]];
        #  gx_t222_opt=(1/(k*p))*M0'*A^(1/2)*(Qtilde0)*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)-
        #  (1/(k*p))*M0'*A^(1/2)*(Qtilde0*Mg*inv(Matrix{Float64}(I, k*m, k*m)+Mg'*Qtilde0*Mg)*Mg'*Qtilde0)*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)+[b_opt[1];b_opt[1];b_opt[2];b_opt[2]];
        #  gth=Ygotique_opt-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2)*Ygotique0_opt;
        # μ_emp_opt=zeros(m*k,1);
        # σ_emp_opt=zeros(m*k,1);
        # σ_th_opt=zeros(k,1);
        # μ_emp_opt[1]=mean(gx_s_opt[1:n_test[1]]);
        # μ_emp_opt[2]=mean(gx_s_opt[1+n_test[1]:n_test[1]+n_test[2]]);
        # μ_emp_opt[3]=mean(gx_t_opt[1:n_test[3]]);
        # μ_emp_opt[4]=mean(gx_t_opt[n_test[3]+1:n_test[3]+n_test[4]]);
        # σ_emp_opt[1]=std(gx_s_opt[1:n_test[1]]).^2;
        # σ_emp_opt[2]=std(gx_s_opt[1+n_test[1]:n_test[1]+n_test[2]]).^2;
        # σ_emp_opt[3]=std(gx_t_opt[1:n_test[3]]).^2;
        # σ_emp_opt[4]=std(gx_t_opt[n_test[3]+1:end]).^2;
        # #Calcul empirique error
        # pred_source_opt=zeros(size(X_test)[2],1);pred_target_opt=zeros(sum(n_test[3:4]),1);
        # threshold_emp_opt=(mean(gx_s_opt[1:n_test[1]])+mean(gx_s_opt[1+n_test[1]:end]))/2;
        # pred_source_opt[gx_s_opt.<threshold_emp_opt*ones(size(X_test)[2],1)].=-1;pred_source_opt[gx_s_opt.>threshold_emp_opt*ones(size(X_test)[2],1)].=1;
        # threshold_emp_target_opt=(mean(gx_t_opt[1:n_test[3]])+mean(gx_t_opt[1+n_test[3]:end]))/2;
        # pred_target_opt[gx_t_opt.<threshold_emp_target_opt*ones(sum(n_test[3:4]),1)].=-1;pred_target_opt[gx_t_opt.>threshold_emp_target_opt*ones(sum(n_test[3:4]),1)].=1;
        # error_source_emp_opt=sum(pred_source_opt.!=y_test)./size(X_test)[2];
        # error_target_emp_opt=sum(pred_target_opt.!=y_test1)./sum(n_test[3:4]);
        #Calcul théorique des erreurs
        Ygotique_opt=y_tilde_opt;Ygotique0_opt=y_tilde_opt0;
        μ_th_opt=Ygotique_opt-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2)*Ygotique0_opt;
        σ_th_opt=zeros(k,1);
        V=zeros(k*m,k*m,k)
        for i=1:k
                V[:,:,i]=diagm(vec(kron(κ[i,:],ones(k,1))))+kron(Agotique*((1/δ_tilde1[i])*diagm(vec(e_i[:,i]*(1+LUM3[i]))))*Agotique,ones(k,1)*ones(1,k)).*MM;
                σ_th_opt[i]=Ygotique0_opt'*diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,i]*Γ)*diagm(vec(δ_tilde))^(1/2)*Ygotique0_opt;
        end
        # error_source_th_opt=(n_test[1]/size(X_test)[2])*0.5*erfc((μ_th_opt[1]-μ_th_opt[2])./(2*sqrt(2)*sqrt(σ_th_opt[1])))+(n_test[2]/size(X_test)[2])*0.5*erfc((μ_th_opt[1]-μ_th_opt[2])./(2*sqrt(2)*sqrt(σ_th_opt[1])));
        # error_target_th_opt=(n_test[3]/sum(n_test[3:4]))*0.5*erfc((μ_th_opt[3]-μ_th_opt[4])./(2*sqrt(2)*sqrt(σ_th_opt[2])))+(n_test[4]/sum(n_test[3:4]))*0.5*erfc((μ_th_opt[3]-μ_th_opt[4])./(2*sqrt(2)*sqrt(σ_th_opt[2])));
        # p1=histogram(gx_s[n_test[1]+1:end],normalize = true,alpha=0.5,bins=100);
        # p1=histogram!(gx_s[1:n_test[1]],normalize = true,alpha=0.5,bins=100);
        # p1=plot!(Normal(μ_th[1],sqrt(σ_th[1])));
        # p1=plot!(Normal(μ_th[2],sqrt(σ_th[1])));
        # display(p1)
        # p2=histogram(gx_t[n_test[3]+1:end],normalize = true,alpha=0.5,bins=100);
        # p2=histogram!(gx_t[1:n_test[3]],normalize = true,alpha=0.5,bins=100);
        # p2=plot!(Normal(μ_th[3],sqrt(σ_th[2])));
        # p2=plot!(Normal(μ_th[4],sqrt(σ_th[2])));
        # display(p2)
        # p3=histogram(gx_s_opt[n_test[1]+1:end],normalize = true,alpha=0.5,bins=100);
        # p3=histogram!(gx_s_opt[1:n_test[1]],normalize = true,alpha=0.5,bins=100);
        # p3=plot!(Normal(μ_th_opt[1],sqrt(σ_th_opt[1])));
        # p3=plot!(Normal(μ_th_opt[2],sqrt(σ_th_opt[1])));
        # display(p3)
        # p4=histogram(gx_t_opt[n_test[3]+1:end],normalize = true,alpha=0.5,bins=100);
        # p4=histogram!(gx_t_opt[1:n_test[3]],normalize = true,alpha=0.5,bins=100);
        # p4=plot!(Normal(μ_th_opt[3],sqrt(σ_th_opt[2])));
        # p4=plot!(Normal(μ_th_opt[4],sqrt(σ_th_opt[2])));
        # display(p4)
        return gx_s,gx_t,gx_s_opt,gx_t_opt,σ_th_opt
end
function RMTMTLLSSVM(Sfts,Slabels,Tfts,Tlabels,λ,γ,X_test,X_test1,ns,n_test,tl)
        #Define parameters
        p,nul=size(Tfts);
        y_test=[ones(n_test[1],1);-ones(n_test[2],1)];
        y_test1=[ones(n_test[3],1);-ones(n_test[4],1)];
        #k=numel(X1)+1;
        k=2;
        m=2;
        n=sum(ns);
        c=ns/sum(ns);
        co=k*p/n;
        n1=sum(ns[1:2]);n2=sum(ns[3:4]);
        P=zeros(n,k);
        P[1:n1,1]=ones(n1,1);P[n1+1:end,2]=ones(n2,1);
        A=kron(diagm(γ)+λ*ones(k,1)*ones(1,k),Matrix{Float64}(I, p, p));
        λ=λ./norm(A);γ=γ./norm(A);
        A=kron(diagm(γ)+λ*ones(k,1)*ones(1,k),Matrix{Float64}(I, p, p));
        cons1=1;cons2=1;
        #cons2=((1/(n2*p))*tr(Tfts_c*Tfts_c'));
        #cons1=((1/(n1*p))*tr(Sfts_c*Sfts_c'));
        #Compute statististics of the data.
        #Centering and scaling of the data;
        Mi,Σi=compute_statistics(Sfts,Tfts,ns);
        Sfts_c=(Sfts*(Matrix{Float64}(I, n1, n1)-(1/n1)*ones(n1,1)*ones(1,n1)));
        Sfts_cs=Sfts_c./cons1;
        Tfts_c=(Tfts*(Matrix{Float64}(I, n2, n2)-(1/n2)*ones(n2,1)*ones(1,n2)));
        Tfts_cs=Tfts_c./cons2;
        Mo,Σ=compute_statistics(Sfts_cs,Tfts_cs,ns);
        # M_c_pop_s=sum((ns[j]./n1)*Mo[:,j] for j=1:m)
        # M_c_pop_t=sum((ns[m+j]./n2)*Mo[:,m+j] for j=1:m)
        # M_source_c=Mo[:,1:2]-M_c_pop_s*ones(1,2);
        # M_target_c=Mo[:,3:4]-M_c_pop_t*ones(1,2);
        # M_source_cs=(Mo[:,1:2]-M_c_pop_s*ones(1,2))/((1/(n1*p))*tr(Sfts_c*Sfts_c'));
        # M_target_cs=(Mo[:,3:4]-M_c_pop_t*ones(1,2))/((1/(n2*p))*tr(Tfts_c*Tfts_c'));
        # M=[M_source_cs M_target_cs];
        # M_source=(Mo[:,1]-Mo[:,2])/((1/(n1*p))*tr(Sfts_c*Sfts_c'));
        # M_target=(Mo[:,3]-Mo[:,4])/((1/(n2*p))*tr(Tfts_c*Tfts_c'));
        Σ[:,:,1]=Matrix{Float64}(I, p, p);
        Σ[:,:,2]=Matrix{Float64}(I, p, p);
        Σ[:,:,3]=Matrix{Float64}(I, p, p);
        Σ[:,:,4]=Matrix{Float64}(I, p, p);
        M_cens=sum((ns[j]./n1)*Mi[:,j] for j=1:m);
        X_test=(X_test-M_cens*ones(1,size(X_test)[2]))./cons1;
        M_cent=sum((ns[m*(k-1)+j]./n2)*Mi[:,m*(k-1)+j] for j=1:m)
        X_test1=(X_test1-M_cent*ones(1,sum(n_test[3:4])))./cons2;
        Z=[Sfts_cs zeros(p,n2);zeros(p,n1) Tfts_cs];
        Q=inv((1/(k*p))*Z'*A*Z+Matrix{Float64}(I, n, n));
        y=[Slabels;Tlabels];
        b=(P'*Q*P)\(P'*Q*y);
        # M0=zeros(k*p,m*k);
        # for i=1:k
        #         e_i=zeros(k,1);e_i[i]=1;
        #         for j=1:m
        #                 M0[:,m*(i-1)+j]=kron(e_i,M[:,m*(i-1)+j]);
        #         end
        # end
        e_s=zeros(k,1);e_t=zeros(k,1);
        e_s[1]=1;e_t[2]=1;
        gx_s=(1/(k*p))*kron(e_s,X_test)'*A*Z*Q*(y-P*b)+b[1]*ones(size(X_test)[2],1);
        gx_t=(1/(k*p))*kron(e_t,X_test1)'*A*Z*Q*(y-P*b)+b[2]*ones(sum(n_test[3:4]),1);
        # gx_t2=(1/(k*p))*kron(e_t,X_test1)'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y-P*b)+b[2]*ones(sum(n_test[3:4]),1);
        # gx_t22=(1/(k*p))*kron(e_t,X_test1)'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y-P*b)+b[2]*ones(sum(n_test[3:4]),1);
        # gx_t222=(1/(k*p))*M0[:,3:4]'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y-P*b)+[b[2];b[2]];
        #gx_s2=(1/(k*p))*M0[:,1:2]'*A*Z*Q*(y-P*b)+[b[1];b[1]];
        #gx_t2=(1/(k*p))*M0[:,3:4]'*A*Z*Q*(y-P*b)+[b[2];b[2]];
        μ_emp=zeros(m*k,1);
        σ_emp=zeros(m*k,1);
        σ_th=zeros(k,1);
        μ_emp[1]=mean(gx_s[1:n_test[1]]);
        μ_emp[2]=mean(gx_s[1+n_test[1]:n_test[1]+n_test[2]]);
        μ_emp[3]=mean(gx_t[1:n_test[3]]);
        μ_emp[4]=mean(gx_t[n_test[3]+1:n_test[3]+n_test[4]]);
        σ_emp[1]=std(gx_s[1:n_test[1]]).^2;
        σ_emp[2]=std(gx_s[1+n_test[1]:n_test[1]+n_test[2]]).^2;
        σ_emp[3]=std(gx_t[1:n_test[3]]).^2;
        σ_emp[4]=std(gx_t[n_test[3]+1:end]).^2;
        #Calcul covariance généralisé
        # C=zeros(k*p,k*p,m*k);
        # for i=1:k
        #         e_i=zeros(k,1);e_i[i]=1;
        #         for j=1:m
        #                 C[:,:,m*(i-1)+j]=A^(1/2)*kron(e_i*e_i',Σ[:,:,m*(i-1)+j]+M[:,m*(i-1)+j]*M[:,m*(i-1)+j]')*A^(1/2);
        #         end
        # end
        #Calcul du delta
        #δ,Qbar=delta_function(C,k,m,p,ns);
        # δe,Qbar=delta_function(C,k,m,p,ns,λ,γ);
        # M0=zeros(k*p,m*k);
        # for i=1:k
        #         e_i=zeros(k,1);e_i[i]=1;
        #         for j=1:m
        #                 M0[:,m*(i-1)+j]=kron(e_i,M[:,m*(i-1)+j]);
        #         end
        # end
        # M_δ=M0*diagm(vec(ones(m*k,1)./(ones(m*k,1)+δe)));
        # Mg=A^(1/2)*M0*diagm(sqrt.(vec(c./(co*(ones(m*k,1)+δe)))));
        # invQtilde0=zeros(k*p,k*p);
        # for i=1:k
        #         e_i=zeros(k,1);e_i[i]=1;
        #         for j=1:m
        #                 invQtilde0=invQtilde0+kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i*e_i'*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2),(c[m*(i-1)+j]./(co*(1+δe[m*(i-1)+j])))*Σ[:,:,m*(i-1)+j]);
        #         end
        # end
        # Qtilde0=inv(invQtilde0+Matrix{Float64}(I, k*p, k*p));
        δ=delta_function_identity(k,p,ns,λ,γ);
        cb=zeros(2,k);
        for i=1:k
                cb[:,i]=sqrt(c[m*(i-1)+1]./(sum(c[m*(i-1)+1:m*(i-1)+2])))*sqrt(c[m*(i-1)+2]./(sum(c[m*(i-1)+1:m*(i-1)+2])))*
                [sqrt(c[m*(i-1)+2]./(sum(c[m*(i-1)+1:m*(i-1)+2])));-sqrt(c[m*(i-1)+1]./(sum(c[m*(i-1)+1:m*(i-1)+2])))];
        end
        J=zeros(n,m*k);
         J[1:ns[1],1]=ones(ns[1],1);J[ns[1]+1:ns[1]+ns[2],2]=ones(ns[2],1);J[n1+1:n1+ns[3],3]=ones(ns[3],1);J[n1+ns[3]+1:end,4]=ones(ns[4],1);
        e_i=Matrix{Float64}(I, k, k);
        # J11=zeros(n1,1);J12=zeros(n1,1);
        # J21=zeros(n2,1);J22=zeros(n2,1);
        # J11[1:ns[1],:]=ones(ns[1],1);J12[ns[1]+1:end,:]=ones(ns[2],1);
        # J21[1:ns[3],:]=ones(ns[3],1);J22[ns[3]+1:end,:]=ones(ns[4],1);
        # cardS11=ns[1];cardS12=ns[2];cardS21=ns[3];cardS22=ns[4];
        Δμ=zeros(k,k);
        nd=[n1;n2];
        cardS11=convert(Int,floor(ns[2*(1-1)+1]/2));cardS1p1=convert(Int,ns[2*(1-1)+1]-cardS11);cardS12=convert.(Int,floor(ns[2*(1-1)+2]/2));cardS1p2=convert.(Int,ns[2*(1-1)+2]-cardS12);
        cardS21=convert.(Int,floor(ns[2*(2-1)+1]/2));cardS2p1=convert.(Int,ns[2*(2-1)+1]-cardS21);cardS22=convert.(Int,floor(ns[2*(2-1)+2]/2));cardS2p2=convert.(Int,ns[2*(2-1)+2]-cardS22);
        J_11=zeros(nd[1],1);J_12=zeros(nd[1],1);J_1p1=zeros(nd[1],1);J_1p2=zeros(nd[1],1);
        J_21=zeros(nd[2],1);J_22=zeros(nd[2],1);J_2p1=zeros(nd[2],1);J_2p2=zeros(nd[2],1);
        J_11[1:cardS11].=1;J_1p1[cardS11+1:ns[2*(1-1)+1]].=1;J_12[ns[2*(1-1)+1]+1:ns[2*(1-1)+1]+cardS12].=1;
        J_21[1:cardS21].=1;J_2p1[cardS21+1:ns[2*(2-1)+1]].=1;J_22[ns[2*(2-1)+1]+1:ns[2*(2-1)+1]+cardS22].=1;
        J_1p2[ns[2*(1-1)+1]+cardS12+1:end].=1;
        J_2p2[ns[2*(2-1)+1]+cardS22+1:end].=1;
        Δμ[1,1]=((J_11./cardS11-J_12./cardS12)'*Sfts_cs'*Sfts_cs*(J_1p1./cardS1p1-J_1p2./cardS1p2))[1];
        Δμ[2,2]=((J_21./cardS21-J_22./cardS22)'*Tfts_cs'*Tfts_cs*(J_2p1./cardS2p1-J_2p2./cardS2p2))[1];
        cardS11=ns[2*(1-1)+1];cardS12=ns[2*(1-1)+2];cardS21=ns[2*(2-1)+1];cardS22=ns[2*(2-1)+2];
        J_11=zeros(nd[1],1);J_12=zeros(nd[1],1);J_21=zeros(nd[2],1);J_22=zeros(nd[2],1);
        J_11[1:cardS11].=1;J_21[1:cardS21].=1;J_12[cardS11+1:end].=1;J_22[cardS21+1:end].=1;
        Δμ[1,2]=((J_11./cardS11-J_12./cardS12)'*Sfts_cs'*Tfts_cs*(J_21./cardS21-J_22./cardS22))[1];
        Δμ[2,1]=((J_21./cardS21-J_22./cardS22)'*Tfts_cs'*Sfts_cs*(J_11./cardS11-J_12./cardS12))[1];
        #####Test estimation équivalent déterministe
        # Δμ2=zeros(k,k);
        # Δμ2[1,1]=M_source'*M_source;Δμ2[1,2]=M_source'*M_target;Δμ2[2,1]=M_target'*M_source;
        # Δμ2[2,2]=M_target'*M_target;
        #Δμ=Δμ2;

        # Δ=zeros(p,2)
        # Δ[:,1]=(Sfts_cs*(J_11./cardS11-J_12./cardS12));
        # Δ[:,2]=(Tfts_cs*(J_21./cardS21-J_22./cardS22));
        # Δ[:,1]=(Mo[:,1]-Mo[:,2])./((1/(n1*p))*tr(Sfts_c*Sfts_c'));
        # Δ[:,2]=(Mo[:,3]-Mo[:,4])./((1/(n2*p))*tr(Tfts_c*Tfts_c'));
        # Δ2=zeros(p,2);
        # Δ2[:,1]=(M[:,1]-M[:,2])
        # Δ2[:,2]=(M[:,3]-M[:,4])
        e_j=Matrix{Float64}(I, k*m, k*m);
        c11=c[2*(1-1)+1];c12=c[2*(1-1)+2];c21=c[2*(2-1)+1];c22=c[2*(2-1)+2];
        c1=c11+c12;c2=c21+c22;
        cc=[c1;c2];
        δ_tilde1=zeros(k,1);
        δ_tilde1[1]=c1/(co*(1+δ[1]));δ_tilde1[2]=c2/(co*(1+δ[2]));
        δ_tilde=c./(co*(ones(m*k,1)+kron(δ,ones(m,1))));
        h=[(1/sqrt(δ_tilde1[i]))*(1/cc[i])*sqrt(c[m*(i-1)+1]*c[m*(i-1)+2]./(co*(1+δ[i])))*(sqrt(c[m*(i-1)+2])*e_j[:,m*(i-1)+1]-
        sqrt(c[m*(i-1)+1])*e_j[:,m*(i-1)+2]) for i=1:k];
        #Mg2=sum(kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,i]*e_ij[:,m*(i-1)+j]',sqrt(δ_tilde[m*(i-1)+j])*M[:,m*(i-1)+j]) for i=1:k,j=1:m)
        # Md=[M_source M_target];
        # Mg_t=sum(kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,i]*h[i]',Md[:,i]) for i=1:k)
        Agotique=inv(Matrix{Float64}(I, k, k)+diagm(vec(δ_tilde1))^(-1/2)*inv((diagm(γ)+λ*ones(k,1)*ones(1,k)))*diagm(vec(δ_tilde1))^(-1/2))
        MM=sum(Δμ[i,j]*h[i]*h[j]' for i=1:k,j=1:k);
        Γ=inv(Matrix{Float64}(I, m*k, m*k)+kron(Agotique,ones(k,1)*ones(1,k)).*MM);
        #yo=[1-b[1];-1-b[1];1-b[2];-1-b[2]];
        #gx_s1=(1/(k*p))*kron(e_s,X_test)'*A*Z*Q*(y-P*b)+b[1]*ones(sum(n_test[1:2]),1);
        Ygotique=[1;-1;1;-1];Ygotique0=[1-b[1];-1-b[1];1-b[2];-1-b[2]];
        # (e_ij[:,3]-e_ij[:,4])'*(Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2))*Ygotique
        # (x'*(Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(1/2)*Γ*diagm(vec(δ_tilde))^(-1/2))*(e_ij[:,3]-e_ij[:,4]))
        μ_th=Ygotique-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2)*Ygotique0;
        Dt=diagm(vec([cc[i]./(co*(1+δ[i])^2) for i=1:k]));
        test2=(1/k)*(diagm(vec(δ_tilde1))^(-1/2)*Agotique*diagm(vec(δ_tilde1))^(-1/2)).*(diagm(vec(δ_tilde1))^(-1/2)*Agotique*diagm(vec(δ_tilde1))^(-1/2))
        K=Dt*test2/(Matrix{Float64}(I, k, k)-Dt*test2)
        #KAPPA=diagm(vec(δ_tilde1))^(-1)*K;
        KAPPA=K*diagm(vec(δ_tilde1));
        LUM_test=(test2/(Matrix{Float64}(I, k, k)-Dt*test2))*Dt
        LUM3=sum(LUM_test,dims=2);
        #κ=K*diagm(vec(δ_tilde1))^(-1);
        κ= transpose((co)*diagm(vec(cc))^(-1)*diagm(vec(δ_tilde1))*test2/(Matrix{Float64}(I, k, k)-Dt*test2))
        V=zeros(k*m,k*m,k);
        σ_th=zeros(m*k,1);
        #S1=zeros(k*p,k*p,m*k);
        #d=zeros(k*m,1);
        # Tbar=zeros(m*k,m*k);
        # Tg=zeros(m*k,m*k);
        # σ_th1=zeros(m*k,1);
        # for i=1:k
        #         e_i=zeros(k,1);e_i[i]=1;
        #         for j=1:m
        #                 S1[:,:,m*(i-1)+j]=kron(e_i*e_i',Σ[:,:,m*(i-1)+j]);
        #                 d[m*(i-1)+j]=ns[m*(i-1)+j]./(k*p*(1+δe[m*(i-1)+j])^2)
        #                 for ip=1:k
        #                         for jp=1:m
        #                                 Tbar[m*(i-1)+j,m*(ip-1)+jp]=(1/(k*p))*tr(C[:,:,m*(ip-1)+jp]*Qbar*A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2)*Qbar);
        #                                 Tg[m*(i-1)+j,m*(ip-1)+jp]=(1/(k*p))*tr(C[:,:,m*(i-1)+j]*Qbar*C[:,:,m*(ip-1)+jp]*Qbar);
        #                         end
        #                 end
        #         end
        # end
        # D=diagm(vec(d));
        # T=Tbar/(Matrix{Float64}(I, m*k, m*k)-D*Tg);
        # κ4=zeros(k*m,k*m);
        # Vs=zeros(k*p,k*p,m*k);
        # for i=1:k
        #         for j=1:m
        #                 for ip=1:k
        #                         for jp=1:m
        #                                 κ4[m*(i-1)+j,m*(ip-1)+jp]=d[m*(ip-1)+jp]*T[m*(i-1)+j,m*(ip-1)+jp]/δ_tilde[m*(ip-1)+jp];
        #                         end
        #                 end
        #                 LUM=(Tbar/(Matrix{Float64}(I, m*k, m*k)-D*Tg))*D;
        #                 LUM_test=(test2/(Matrix{Float64}(I, k, k)-Dt*test2))*Dt
        #                 LUM2=[LUM[1,1]+LUM[1,2] LUM[1,3]+LUM[1,4];LUM[3,1]+LUM[3,2] LUM[3,3]+LUM[3,4]];
        #                 LUM3=[LUM2[1,1]+LUM2[1,2];LUM2[2,1]+LUM2[2,2]];
        #                 Sec=sum(δ_tilde[m*(ip-1)+jp]*κ4[m*(i-1)+j,m*(ip-1)+jp]*A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2) for ip=1:k,jp=1:m);
        #                 Sec2=LUM3[i]*A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2);
        #                 #Ve=kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*(e_i[:,i]*e_i[:,i]'+e_i[:,i]*e_i[:,i]'*LUM3[i])*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2),Matrix{Float64}(I, p, p))
        #                 Vs[:,:,m*(i-1)+j]=A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2)+Sec;
        #                 σ_th1[m*(i-1)+j]=Ygotique0'*diagm(vec(δ_tilde))^(1/2)*(Γ*diagm(vec(κ4[m*(i-1)+j,:]))*Γ+Γ*Mg'*Qtilde0*Vs[:,:,m*(i-1)+j]*Qtilde0*Mg*Γ)*diagm(vec(δ_tilde))^(1/2)*Ygotique0;
        #                 #Mg2=sum(kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,i]*h[i]'*sqrt(δ_tilde1[i]),Δ[:,i]) for i=1:k)
        #                 #Qtilde01=kron(inv(Matrix{Float64}(I, k, k)+(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*diagm(vec(δ_tilde1))*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)),Matrix{Float64}(I, p, p))
        #                 test=Mg'*Qtilde0*Vs[:,:,m*(i-1)+j]*Qtilde0*Mg
        #                 KAPPAf=Dt*test2/(Matrix{Float64}(I, k, k)-Dt*test2)
        #                 # test1=sum(kron(sqrt(δ_tilde1[ip])*h[ip]*e_i[:,ip]'*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*inv(Matrix{Float64}(I, k, k)+(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*diagm(vec(δ_tilde1))*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2))*
        #                 # (diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*(e_i[:,i]*e_i[:,i]'+LUM3[i]*e_i[:,i]*e_i[:,i]')*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*inv(Matrix{Float64}(I, k, k)+(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*diagm(vec(δ_tilde1))*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2))*
        #                 # (diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,jp]*h[jp]'*sqrt(δ_tilde1[jp]),Δ[:,ip]'*Δ[:,jp]) for ip=1:k,jp=1:k)
        #         end
        # end
        σ_th=zeros(k,1);
        e_i=Matrix{Float64}(I, k, k);
        for i=1:k
                V[:,:,i]=diagm(vec(kron(κ[i,:],ones(k,1))))+kron(Agotique*((1/δ_tilde1[i])*diagm(vec(e_i[:,i]*(1+LUM3[i]))))*Agotique,ones(k,1)*ones(1,k)).*MM;
                σ_th[i]=Ygotique0'*diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,i]*Γ)*diagm(vec(δ_tilde))^(1/2)*Ygotique0;
        end
        ##################TO DELET###################################
        #############################################
        #Calcul de l'erreur empirique et théorique
        pred_source=zeros(size(X_test)[2],1);pred_target=zeros(size(X_test1)[2],1);
        threshold_emp=(mean(gx_s[1:n_test[1]])+mean(gx_s[1+n_test[1]:end]))/2;
        pred_source[gx_s.<threshold_emp*ones(size(X_test)[2],1)].=-1;pred_source[gx_s.>threshold_emp*ones(size(X_test)[2],1)].=1;
        threshold_emp_target=(mean(gx_t[1:n_test[3]])+mean(gx_t[1+n_test[3]:end]))/2;
        pred_target[gx_t.<threshold_emp_target*ones(sum(n_test[3:4]),1)].=-1;pred_target[gx_t.>threshold_emp_target*ones(sum(n_test[3:4]),1)].=1;
        error_source_emp=sum(pred_source.!=y_test)./size(X_test)[2];
        error_target_emp=sum(pred_target.!=y_test1)./sum(n_test[3:4]);
        error_source_th=(n_test[1]/size(X_test)[2])*0.5*erfc((μ_th[1]-μ_th[2])./(2*sqrt(2)*sqrt(σ_th[1])))+(n_test[2]/size(X_test)[2])*0.5*erfc((μ_th[1]-μ_th[2])./(2*sqrt(2)*sqrt(σ_th[1])));
        error_target_th=(n_test[3]/sum(n_test[3:4]))*0.5*erfc((μ_th[3]-μ_th[4])./(2*sqrt(2)*sqrt(σ_th[2])))+(n_test[4]/sum(n_test[3:4]))*0.5*erfc((μ_th[3]-μ_th[4])./(2*sqrt(2)*sqrt(σ_th[2])));
        # A faire l'optimization par rapport à y.
        e_ij=Matrix{Float64}(I, k*m, k*m);
        Ze=zeros(m*k,m*k);task=1;
        rg_k=1+m*(task-1):2+m*(task-1);
        Ze[rg_k,rg_k]=[(1-ns[m*(task-1)+1]/n1) -ns[m*(task-1)+2]/n1;-ns[m*(task-1)+1]/n1 (1-ns[m*(task-1)+2]/n1)];
        rg_t=1+m*(k-1):2+m*(k-1);
        Ze[rg_t,rg_t]=[(1-ns[m*(k-1)+1]/n2) -ns[m*(k-1)+2]/n2; (-ns[m*(k-1)+1]/n2) (1-ns[m*(k-1)+2]/n2)];
        #y_tilde_opt0=diagm(vec(δ_tilde))^(-1/2)*inv(Γ)*inv(V[:,:,2])*(kron(Agotique,ones(k,1)*ones(1,k)).*MM)*diagm(vec(δ_tilde))^(-1/2)*(e_ij[:,3]-e_ij[:,4]);
        res = optimize(x->(-(x'*(Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2))*(e_ij[:,3]-e_ij[:,4]))^2/
         (8*x'*diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,2]*Γ)*diagm(vec(δ_tilde))^(1/2)*x)), Ze*[1.0;-1.0;1.0;-1.0])
        y_tilde_opt0=Optim.minimizer(res);
        # y_tilde_opt0=inv(diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,2]*Γ)*diagm(vec(δ_tilde))^(1/2))*
        # (Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(1/2)*Γ*diagm(vec(δ_tilde))^(-1/2))*(e_ij[:,3]-e_ij[:,4])
        y_tilde_opt0=y_tilde_opt0./norm(y_tilde_opt0);
        # x1=Ze*[1.0;-1.0;1.0;-1.0];
        # x2=y_tilde_opt0;
        # y_tilde_opt02=diagm(vec(δ_tilde))^(-1/2)*(inv(Γ)*inv(V[:,:,2])*inv(Γ))*diagm(vec(δ_tilde))^(-1/2)*
        # (Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2))*(e_ij[:,3]-e_ij[:,4])
        # err2=0.5*erfc(sqrt(-res(y_tilde_opt01)));
        # err=0.5*erfc(sqrt(-Optim.minimum(res)));
        y_tilde_opt=pinv(Ze)*y_tilde_opt0;
        y_tilde_opt=Ygotique;
        #y_tilde_opt=Ze\y_tilde_opt0;
        y_tilde_opt0=Ze*y_tilde_opt;
        # optim1=(x1'*(Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2))*(e_ij[:,3]-e_ij[:,4]))^2/(8*x1'*diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,2]*Γ)*diagm(vec(δ_tilde))^(1/2)*x1)
        # optim2=(x2'*(Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2))*(e_ij[:,3]-e_ij[:,4]))^2/(8*x2'*diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,2]*Γ)*diagm(vec(δ_tilde))^(1/2)*x2)
        #y_tilde_opt=pinv(Ze,rtol=1e-12)*y_tilde_opt0;

        #Calcul empirique
        ez=zeros(k*m,1);ez[m+2]=1;er=[0;1];
        #meanf!(sol)=(((y_tilde_opt+kron(er,sol*ones(m,1)))-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2)*Ze*(y_tilde_opt+kron(er,sol*ones(m,1))))'*ez)[1];
        function meanfg!(sol)
                return (((y_tilde_opt+kron(er,sol*ones(m,1)))-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2)*Ze*(y_tilde_opt+kron(er,sol*ones(m,1))))'*ez)[1]
        end
        asolve=nlsolve(n_ary(meanfg!),[1.0]);
        y_tilde_opt=y_tilde_opt+kron(er,asolve.zero[1]*ones(m,1));
        y_opt=J*y_tilde_opt;
        ##################################
        #######################
        b_opt=(P'*Q*P)\(P'*Q*y_opt);
        gx_s_opt=(1/(k*p))*kron(e_s,X_test)'*A*Z*Q*(y_opt-P*b_opt)+b_opt[1]*ones(size(X_test)[2],1);
        gx_t_opt=(1/(k*p))*kron(e_t,X_test1)'*A*Z*Q*(y_opt-P*b_opt)+b_opt[2]*ones(size(X_test1)[2],1);
        # gx_t_opt2=(1/(k*p))*kron(e_t,X_test1)'*A^(1/2)*Qtilde*A^(1/2)*Z*(y_opt-P*b_opt)+b_opt[2]*ones(sum(n_test[3:4]),1);
        # Qtilde=inv((1/(k*p))*A^(1/2)*Z*Z'*A^(1/2)+Matrix{Float64}(I, k*p, k*p));
        #  gx_t2_opt=(1/(k*p))*kron(e_t,X_test1)'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)+b_opt[2]*ones(sum(n_test[3:4]),1);
        #  gx_t22_opt=(1/(k*p))*kron(e_t,X_test1)'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)+b_opt[2]*ones(sum(n_test[3:4]),1);
        #  gx_t2221_opt=(1/(k*p))*kron(e_t,mean(X_test1[:,1:n_test[1]],dims=2))'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)+[b_opt[2]];
        #  gx_t222_opt=(1/(k*p))*M0'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)+[b_opt[1];b_opt[1];b_opt[2];b_opt[2]];
        #  gx_t222_opt=(1/(k*p))*M0'*A^(1/2)*(Qtilde0)*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)-
        #  (1/(k*p))*M0'*A^(1/2)*(Qtilde0*Mg*inv(Matrix{Float64}(I, k*m, k*m)+Mg'*Qtilde0*Mg)*Mg'*Qtilde0)*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)+[b_opt[1];b_opt[1];b_opt[2];b_opt[2]];
        #  gth=Ygotique_opt-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2)*Ygotique0_opt;
        μ_emp_opt=zeros(m*k,1);
        σ_emp_opt=zeros(m*k,1);
        σ_th_opt=zeros(k,1);
        μ_emp_opt[1]=mean(gx_s_opt[1:n_test[1]]);
        μ_emp_opt[2]=mean(gx_s_opt[1+n_test[1]:n_test[1]+n_test[2]]);
        μ_emp_opt[3]=mean(gx_t_opt[1:n_test[3]]);
        μ_emp_opt[4]=mean(gx_t_opt[n_test[3]+1:n_test[3]+n_test[4]]);
        σ_emp_opt[1]=std(gx_s_opt[1:n_test[1]]).^2;
        σ_emp_opt[2]=std(gx_s_opt[1+n_test[1]:n_test[1]+n_test[2]]).^2;
        σ_emp_opt[3]=std(gx_t_opt[1:n_test[3]]).^2;
        σ_emp_opt[4]=std(gx_t_opt[n_test[3]+1:end]).^2;
        # #Calcul empirique error
        pred_source_opt=zeros(size(X_test)[2],1);pred_target_opt=zeros(sum(n_test[3:4]),1);
        threshold_emp_opt=(mean(gx_s_opt[1:n_test[1]])+mean(gx_s_opt[1+n_test[1]:end]))/2;
        pred_source_opt[gx_s_opt.<threshold_emp_opt*ones(size(X_test)[2],1)].=-1;pred_source_opt[gx_s_opt.>threshold_emp_opt*ones(size(X_test)[2],1)].=1;
        threshold_emp_target_opt=(mean(gx_t_opt[1:n_test[3]])+mean(gx_t_opt[1+n_test[3]:end]))/2;
        pred_target_opt[gx_t_opt.<threshold_emp_target_opt*ones(sum(n_test[3:4]),1)].=-1;pred_target_opt[gx_t_opt.>threshold_emp_target_opt*ones(sum(n_test[3:4]),1)].=1;
        error_source_emp_opt=sum(pred_source_opt.!=y_test)./size(X_test)[2];
        error_target_emp_opt=sum(pred_target_opt.!=y_test1)./sum(n_test[3:4]);
        #Calcul théorique des erreurs
        Ygotique_opt=y_tilde_opt;Ygotique0_opt=y_tilde_opt0;
        μ_th_opt=Ygotique_opt-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2)*Ygotique0_opt;
        σ_th_opt=zeros(k,1);
        V=zeros(k*m,k*m,k);
        e_i=Matrix{Float64}(I, k, k);
        for i=1:k
                V[:,:,i]=diagm(vec(kron(κ[i,:],ones(k,1))))+kron(Agotique*((1/δ_tilde1[i])*diagm(vec(e_i[:,i]*(1+LUM3[i]))))*Agotique,ones(k,1)*ones(1,k)).*MM;
                σ_th_opt[i]=Ygotique0_opt'*diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,i]*Γ)*diagm(vec(δ_tilde))^(1/2)*Ygotique0_opt;
        end
        error_source_th_opt=(n_test[1]/size(X_test)[2])*0.5*erfc((μ_th_opt[1]-μ_th_opt[2])./(2*sqrt(2)*sqrt(abs(σ_th_opt[1]))))+(n_test[2]/size(X_test)[2])*0.5*erfc((μ_th_opt[1]-μ_th_opt[2])./(2*sqrt(2)*sqrt(abs(σ_th_opt[1]))));
        error_target_th_opt=(n_test[3]/sum(n_test[3:4]))*0.5*erfc((μ_th_opt[3]-μ_th_opt[4])./(2*sqrt(2)*sqrt(abs(σ_th_opt[2]))))+(n_test[4]/sum(n_test[3:4]))*0.5*erfc((μ_th_opt[3]-μ_th_opt[4])./(2*sqrt(2)*sqrt(abs(σ_th_opt[2]))));
        p1=histogram(gx_s[n_test[1]+1:end],normalize = true,alpha=0.5,bins=100);
        p1=histogram!(gx_s[1:n_test[1]],normalize = true,alpha=0.5,bins=100);
        p1=plot!(Normal(μ_th[1],sqrt(abs(σ_th[1]))));
        p1=plot!(Normal(μ_th[2],sqrt(abs(σ_th[1]))));
        display(p1)
        p2=histogram(gx_t[n_test[3]+1:end],normalize = true,alpha=0.5,bins=100);
        p2=histogram!(gx_t[1:n_test[3]],normalize = true,alpha=0.5,bins=100);
        p2=plot!(Normal(μ_th[3],sqrt(abs(σ_th[2]))));
        p2=plot!(Normal(μ_th[4],sqrt(abs(σ_th[2]))));
        display(p2)
        p3=histogram(gx_s_opt[n_test[1]+1:end],normalize = true,alpha=0.5,bins=100);
        p3=histogram!(gx_s_opt[1:n_test[1]],normalize = true,alpha=0.5,bins=100);
        p3=plot!(Normal(μ_th_opt[1],sqrt(abs(σ_th_opt[1]))));
        p3=plot!(Normal(μ_th_opt[2],sqrt(abs(σ_th_opt[1]))));
        display(p3)
        p4=histogram(gx_t_opt[n_test[3]+1:end],normalize = true,alpha=0.5,bins=100);
        p4=histogram!(gx_t_opt[1:n_test[3]],normalize = true,alpha=0.5,bins=100);
        p4=plot!(Normal(μ_th_opt[3],sqrt(abs(σ_th_opt[2]))));
        p4=plot!(Normal(μ_th_opt[4],sqrt(abs(σ_th_opt[2]))));
        display(p4)
        return gx_s,gx_t,μ_th,μ_emp,σ_th,σ_emp,error_source_emp,error_target_emp,error_source_th,error_target_th,
        gx_s_opt,gx_t_opt,μ_th_opt,μ_emp_opt,σ_th_opt,σ_emp_opt,error_source_emp_opt,error_target_emp_opt,error_source_th_opt,error_target_th_opt
end
function RMTMTLLSSVM(Sfts,Slabels,Tfts,Tlabels,λ,γ,X_test,X_test1,ns,n_test)
        #Define parameters
        p,nul=size(Tfts);
        y_test=[ones(n_test[1],1);-ones(n_test[2],1)];
        y_test1=[ones(n_test[3],1);-ones(n_test[4],1)];
        #k=numel(X1)+1;
        k=2;
        m=2
        n=sum(ns);
        c=ns/sum(ns);
        co=k*p/n;
        n1=sum(ns[1:2]);n2=sum(ns[3:4]);
        P=zeros(n,k);
        P[1:n1,1]=ones(n1,1);P[n1+1:end,2]=ones(n2,1);
        A=kron(diagm(γ)+λ*ones(k,1)*ones(1,k),Matrix{Float64}(I, p, p));
        λ=λ./norm(A);γ=γ./norm(A);
        A=kron(diagm(γ)+λ*ones(k,1)*ones(1,k),Matrix{Float64}(I, p, p));
        cons1=1;cons2=1;
        #cons2=((1/(n2*p))*tr(Tfts_c*Tfts_c'));
        #cons1=((1/(n1*p))*tr(Sfts_c*Sfts_c'));
        #Compute statististics of the data.
        #Centering and scaling of the data;
        Mi,Σi=compute_statistics(Sfts,Tfts,ns);
        Sfts_c=(Sfts*(Matrix{Float64}(I, n1, n1)-(1/n1)*ones(n1,1)*ones(1,n1)));
        Sfts_cs=Sfts_c./cons1;
        Tfts_c=(Tfts*(Matrix{Float64}(I, n2, n2)-(1/n2)*ones(n2,1)*ones(1,n2)));
        Tfts_cs=Tfts_c./cons2;
        Mo,Σ=compute_statistics(Sfts_cs,Tfts_cs,ns);
        # M_c_pop_s=sum((ns[j]./n1)*Mo[:,j] for j=1:m)
        # M_c_pop_t=sum((ns[m+j]./n2)*Mo[:,m+j] for j=1:m)
        # M_source_c=Mo[:,1:2]-M_c_pop_s*ones(1,2);
        # M_target_c=Mo[:,3:4]-M_c_pop_t*ones(1,2);
        # M_source_cs=(Mo[:,1:2]-M_c_pop_s*ones(1,2))/((1/(n1*p))*tr(Sfts_c*Sfts_c'));
        # M_target_cs=(Mo[:,3:4]-M_c_pop_t*ones(1,2))/((1/(n2*p))*tr(Tfts_c*Tfts_c'));
        # M=[M_source_cs M_target_cs];
        # M_source=(Mo[:,1]-Mo[:,2])/((1/(n1*p))*tr(Sfts_c*Sfts_c'));
        # M_target=(Mo[:,3]-Mo[:,4])/((1/(n2*p))*tr(Tfts_c*Tfts_c'));
        Σ[:,:,1]=Matrix{Float64}(I, p, p);
        Σ[:,:,2]=Matrix{Float64}(I, p, p);
        Σ[:,:,3]=Matrix{Float64}(I, p, p);
        Σ[:,:,4]=Matrix{Float64}(I, p, p);
        M_cens=sum((ns[j]./n1)*Mi[:,j] for j=1:m);
        X_test=(X_test-M_cens*ones(1,size(X_test)[2]))./cons1;
        M_cent=sum((ns[m*(k-1)+j]./n2)*Mi[:,m*(k-1)+j] for j=1:m)
        X_test1=(X_test1-M_cent*ones(1,sum(n_test[3:4])))./cons2;
        #M=[M_cens M_cent];
        Z=[Sfts_cs zeros(p,n2);zeros(p,n1) Tfts_cs];
        Q=inv((1/(k*p))*Z'*A*Z+Matrix{Float64}(I, n, n));
        y=[Slabels;Tlabels];
        b=(P'*Q*P)\(P'*Q*y);
        # M0=zeros(k*p,m*k);
        # for i=1:k
        #         e_i=zeros(k,1);e_i[i]=1;
        #         for j=1:m
        #                 M0[:,m*(i-1)+j]=kron(e_i,M[:,m*(i-1)+j]);
        #         end
        # end
        e_s=zeros(k,1);e_t=zeros(k,1);
        e_s[1]=1;e_t[2]=1;
        gx_s=(1/(k*p))*kron(e_s,X_test)'*A*Z*Q*(y-P*b)+b[1]*ones(size(X_test)[2],1);
        gx_t=(1/(k*p))*kron(e_t,X_test1)'*A*Z*Q*(y-P*b)+b[2]*ones(sum(n_test[3:4]),1);
        # gx_t2=(1/(k*p))*kron(e_t,X_test1)'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y-P*b)+b[2]*ones(sum(n_test[3:4]),1);
        # gx_t22=(1/(k*p))*kron(e_t,X_test1)'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y-P*b)+b[2]*ones(sum(n_test[3:4]),1);
        # gx_t222=(1/(k*p))*M0[:,3:4]'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y-P*b)+[b[2];b[2]];
        #gx_s2=(1/(k*p))*M0[:,1:2]'*A*Z*Q*(y-P*b)+[b[1];b[1]];
        #gx_t2=(1/(k*p))*M0[:,3:4]'*A*Z*Q*(y-P*b)+[b[2];b[2]];
        μ_emp=zeros(m*k,1);
        σ_emp=zeros(m*k,1);
        σ_th=zeros(k,1);
        μ_emp[1]=mean(gx_s[1:n_test[1]]);
        μ_emp[2]=mean(gx_s[1+n_test[1]:n_test[1]+n_test[2]]);
        μ_emp[3]=mean(gx_t[1:n_test[3]]);
        μ_emp[4]=mean(gx_t[n_test[3]+1:n_test[3]+n_test[4]]);
        σ_emp[1]=std(gx_s[1:n_test[1]]).^2;
        σ_emp[2]=std(gx_s[1+n_test[1]:n_test[1]+n_test[2]]).^2;
        σ_emp[3]=std(gx_t[1:n_test[3]]).^2;
        σ_emp[4]=std(gx_t[n_test[3]+1:end]).^2;
        #Calcul covariance généralisé
        C=zeros(k*p,k*p,m*k);
        for i=1:k
                e_i=zeros(k,1);e_i[i]=1;
                for j=1:m
                        C[:,:,m*(i-1)+j]=A^(1/2)*kron(e_i*e_i',Σ[:,:,m*(i-1)+j]+Mo[:,m*(i-1)+j]*Mo[:,m*(i-1)+j]')*A^(1/2);
                end
        end
        #Calcul du delta
        #δ,Qbar=delta_function(C,k,m,p,ns);
        δe,Qbar=delta_function(C,k,m,p,ns,λ,γ);
        M0=zeros(k*p,m*k);
        for i=1:k
                e_i=zeros(k,1);e_i[i]=1;
                for j=1:m
                        M0[:,m*(i-1)+j]=kron(e_i,M[:,m*(i-1)+j]);
                end
        end
        M_δ=M0*diagm(vec(ones(m*k,1)./(ones(m*k,1)+δe)));
        Mg=A^(1/2)*M0*diagm(sqrt.(vec(c./(co*(ones(m*k,1)+δe)))));
        invQtilde0=zeros(k*p,k*p);
        for i=1:k
                e_i=zeros(k,1);e_i[i]=1;
                for j=1:m
                        invQtilde0=invQtilde0+kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i*e_i'*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2),(c[m*(i-1)+j]./(co*(1+δe[m*(i-1)+j])))*Σ[:,:,m*(i-1)+j]);
                end
        end
        Qtilde0=inv(invQtilde0+Matrix{Float64}(I, k*p, k*p));
        δ=delta_function_identity(k,p,ns,λ,γ);
        cb=zeros(2,k);
        for i=1:k
                cb[:,i]=sqrt(c[m*(i-1)+1]./(sum(c[m*(i-1)+1:m*(i-1)+2])))*sqrt(c[m*(i-1)+2]./(sum(c[m*(i-1)+1:m*(i-1)+2])))*
                [sqrt(c[m*(i-1)+2]./(sum(c[m*(i-1)+1:m*(i-1)+2])));-sqrt(c[m*(i-1)+1]./(sum(c[m*(i-1)+1:m*(i-1)+2])))];
        end
        J=zeros(n,m*k);
         J[1:ns[1],1]=ones(ns[1],1);J[ns[1]+1:ns[1]+ns[2],2]=ones(ns[2],1);J[n1+1:n1+ns[3],3]=ones(ns[3],1);J[n1+ns[3]+1:end,4]=ones(ns[4],1);
        e_i=Matrix{Float64}(I, k, k);
        # J11=zeros(n1,1);J12=zeros(n1,1);
        # J21=zeros(n2,1);J22=zeros(n2,1);
        # J11[1:ns[1],:]=ones(ns[1],1);J12[ns[1]+1:end,:]=ones(ns[2],1);
        # J21[1:ns[3],:]=ones(ns[3],1);J22[ns[3]+1:end,:]=ones(ns[4],1);
        # cardS11=ns[1];cardS12=ns[2];cardS21=ns[3];cardS22=ns[4];
        Δμ=zeros(k,k);
        nd=[n1;n2];
        cardS11=convert(Int,floor(ns[2*(1-1)+1]/2));cardS1p1=convert(Int,ns[2*(1-1)+1]-cardS11);cardS12=convert.(Int,floor(ns[2*(1-1)+2]/2));cardS1p2=convert.(Int,ns[2*(1-1)+2]-cardS12);
        cardS21=convert.(Int,floor(ns[2*(2-1)+1]/2));cardS2p1=convert.(Int,ns[2*(2-1)+1]-cardS21);cardS22=convert.(Int,floor(ns[2*(2-1)+2]/2));cardS2p2=convert.(Int,ns[2*(2-1)+2]-cardS22);
        J_11=zeros(nd[1],1);J_12=zeros(nd[1],1);J_1p1=zeros(nd[1],1);J_1p2=zeros(nd[1],1);
        J_21=zeros(nd[2],1);J_22=zeros(nd[2],1);J_2p1=zeros(nd[2],1);J_2p2=zeros(nd[2],1);
        J_11[1:cardS11].=1;J_1p1[cardS11+1:ns[2*(1-1)+1]].=1;J_12[ns[2*(1-1)+1]+1:ns[2*(1-1)+1]+cardS12].=1;
        J_21[1:cardS21].=1;J_2p1[cardS21+1:ns[2*(2-1)+1]].=1;J_22[ns[2*(2-1)+1]+1:ns[2*(2-1)+1]+cardS22].=1;
        J_1p2[ns[2*(1-1)+1]+cardS12+1:end].=1;
        J_2p2[ns[2*(2-1)+1]+cardS22+1:end].=1;
        Δμ[1,1]=((J_11./cardS11-J_12./cardS12)'*Sfts_cs'*Sfts_cs*(J_1p1./cardS1p1-J_1p2./cardS1p2))[1];
        Δμ[2,2]=((J_21./cardS21-J_22./cardS22)'*Tfts_cs'*Tfts_cs*(J_2p1./cardS2p1-J_2p2./cardS2p2))[1];
        cardS11=ns[2*(1-1)+1];cardS12=ns[2*(1-1)+2];cardS21=ns[2*(2-1)+1];cardS22=ns[2*(2-1)+2];
        J_11=zeros(nd[1],1);J_12=zeros(nd[1],1);J_21=zeros(nd[2],1);J_22=zeros(nd[2],1);
        J_11[1:cardS11].=1;J_21[1:cardS21].=1;J_12[cardS11+1:end].=1;J_22[cardS21+1:end].=1;
        Δμ[1,2]=((J_11./cardS11-J_12./cardS12)'*Sfts_cs'*Tfts_cs*(J_21./cardS21-J_22./cardS22))[1];
        Δμ[2,1]=((J_21./cardS21-J_22./cardS22)'*Tfts_cs'*Sfts_cs*(J_11./cardS11-J_12./cardS12))[1];
        #####Test estimation équivalent déterministe
        # Δμ2=zeros(k,k);
        # Δμ2[1,1]=M_source'*M_source;Δμ2[1,2]=M_source'*M_target;Δμ2[2,1]=M_target'*M_source;
        # Δμ2[2,2]=M_target'*M_target;
        #Δμ=Δμ2;

        Δ=zeros(p,2)
        Δ[:,1]=(Sfts_cs*(J_11./cardS11-J_12./cardS12));
        Δ[:,2]=(Tfts_cs*(J_21./cardS21-J_22./cardS22));
        Δ[:,1]=(Mo[:,1]-Mo[:,2])./((1/(n1*p))*tr(Sfts_c*Sfts_c'));
        Δ[:,2]=(Mo[:,3]-Mo[:,4])./((1/(n2*p))*tr(Tfts_c*Tfts_c'));
        Δ2=zeros(p,2);
        Δ2[:,1]=(M[:,1]-M[:,2])
        Δ2[:,2]=(M[:,3]-M[:,4])
        e_j=Matrix{Float64}(I, k*m, k*m);
        c11=c[2*(1-1)+1];c12=c[2*(1-1)+2];c21=c[2*(2-1)+1];c22=c[2*(2-1)+2];
        c1=c11+c12;c2=c21+c22;
        cc=[c1;c2];
        δ_tilde1=zeros(k,1);
        δ_tilde1[1]=c1/(co*(1+δ[1]));δ_tilde1[2]=c2/(co*(1+δ[2]));
        δ_tilde=c./(co*(ones(m*k,1)+kron(δ,ones(m,1))));
        h=[(1/sqrt(δ_tilde1[i]))*(1/cc[i])*sqrt(c[m*(i-1)+1]*c[m*(i-1)+2]./(co*(1+δ[i])))*(sqrt(c[m*(i-1)+2])*e_j[:,m*(i-1)+1]-
        sqrt(c[m*(i-1)+1])*e_j[:,m*(i-1)+2]) for i=1:k];
        #Mg2=sum(kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,i]*e_ij[:,m*(i-1)+j]',sqrt(δ_tilde[m*(i-1)+j])*M[:,m*(i-1)+j]) for i=1:k,j=1:m)
        # Md=[M_source M_target];
        # Mg_t=sum(kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,i]*h[i]',Md[:,i]) for i=1:k)
        Agotique=inv(Matrix{Float64}(I, k, k)+diagm(vec(δ_tilde1))^(-1/2)*inv((diagm(γ)+λ*ones(k,1)*ones(1,k)))*diagm(vec(δ_tilde1))^(-1/2))
        MM=sum(Δμ[i,j]*h[i]*h[j]' for i=1:k,j=1:k);
        Γ=inv(Matrix{Float64}(I, m*k, m*k)+kron(Agotique,ones(k,1)*ones(1,k)).*MM);
        #yo=[1-b[1];-1-b[1];1-b[2];-1-b[2]];
        #gx_s1=(1/(k*p))*kron(e_s,X_test)'*A*Z*Q*(y-P*b)+b[1]*ones(sum(n_test[1:2]),1);
        Ygotique=[1;-1;1;-1];Ygotique0=[1-b[1];-1-b[1];1-b[2];-1-b[2]];
        # (e_ij[:,3]-e_ij[:,4])'*(Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2))*Ygotique
        # (x'*(Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(1/2)*Γ*diagm(vec(δ_tilde))^(-1/2))*(e_ij[:,3]-e_ij[:,4]))
        μ_th=Ygotique-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2)*Ygotique0;
        Dt=diagm(vec([cc[i]./(co*(1+δ[i])^2) for i=1:k]));
        test2=(1/k)*(diagm(vec(δ_tilde1))^(-1/2)*Agotique*diagm(vec(δ_tilde1))^(-1/2)).*(diagm(vec(δ_tilde1))^(-1/2)*Agotique*diagm(vec(δ_tilde1))^(-1/2))
        K=Dt*test2/(Matrix{Float64}(I, k, k)-Dt*test2)
        #KAPPA=diagm(vec(δ_tilde1))^(-1)*K;
        KAPPA=K*diagm(vec(δ_tilde1));
        LUM_test=(test2/(Matrix{Float64}(I, k, k)-Dt*test2))*Dt
        LUM3=sum(LUM_test,dims=2);
        #κ=K*diagm(vec(δ_tilde1))^(-1);
        κ= transpose((co)*diagm(vec(cc))^(-1)*diagm(vec(δ_tilde1))*test2/(Matrix{Float64}(I, k, k)-Dt*test2))
        V=zeros(k*m,k*m,k);
        σ_th=zeros(m*k,1);
        S1=zeros(k*p,k*p,m*k);
        d=zeros(k*m,1);
        Tbar=zeros(m*k,m*k);
        Tg=zeros(m*k,m*k);
        σ_th1=zeros(m*k,1);
        for i=1:k
                e_i=zeros(k,1);e_i[i]=1;
                for j=1:m
                        S1[:,:,m*(i-1)+j]=kron(e_i*e_i',Σ[:,:,m*(i-1)+j]);
                        d[m*(i-1)+j]=ns[m*(i-1)+j]./(k*p*(1+δe[m*(i-1)+j])^2)
                        for ip=1:k
                                for jp=1:m
                                        Tbar[m*(i-1)+j,m*(ip-1)+jp]=(1/(k*p))*tr(C[:,:,m*(ip-1)+jp]*Qbar*A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2)*Qbar);
                                        Tg[m*(i-1)+j,m*(ip-1)+jp]=(1/(k*p))*tr(C[:,:,m*(i-1)+j]*Qbar*C[:,:,m*(ip-1)+jp]*Qbar);
                                end
                        end
                end
        end
        D=diagm(vec(d));
        T=Tbar/(Matrix{Float64}(I, m*k, m*k)-D*Tg);
        κ4=zeros(k*m,k*m);
        V=zeros(k*p,k*p,m*k);
        Mat=zeros(m*k,m*k,m*k);
        for i=1:k
                for j=1:m
                        for ip=1:k
                                for jp=1:m
                                        κ4[m*(i-1)+j,m*(ip-1)+jp]=d[m*(ip-1)+jp]*T[m*(i-1)+j,m*(ip-1)+jp]/δ_tilde[m*(ip-1)+jp];
                                end
                        end
                        # LUM=(Tbar/(Matrix{Float64}(I, m*k, m*k)-D*Tg))*D;
                        # LUM_test=(test2/(Matrix{Float64}(I, k, k)-Dt*test2))*Dt
                        # LUM2=[LUM[1,1]+LUM[1,2] LUM[1,3]+LUM[1,4];LUM[3,1]+LUM[3,2] LUM[3,3]+LUM[3,4]];
                        # LUM3=[LUM2[1,1]+LUM2[1,2];LUM2[2,1]+LUM2[2,2]];
                        Sec=sum(δ_tilde[m*(ip-1)+jp]*κ4[m*(i-1)+j,m*(ip-1)+jp]*A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2) for ip=1:k,jp=1:m);
                        # Sec2=LUM3[i]*A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2);
                        # Ve=kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*(e_i[:,i]*e_i[:,i]'+e_i[:,i]*e_i[:,i]'*LUM3[i])*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2),Matrix{Float64}(I, p, p))
                        V[:,:,m*(i-1)+j]=A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2)+Sec;
                        Mat[:,:,m*(i-1)+j]=diagm(vec(δ_tilde))^(1/2)*(Γ*diagm(vec(κ4[m*(i-1)+j,:]))*Γ+Γ*Mg'*Qtilde0*V[:,:,m*(i-1)+j]*Qtilde0*Mg*Γ)*diagm(vec(δ_tilde))^(1/2);
                        σ_th[m*(i-1)+j]=Ygotique0'*Mat[:,:,m*(i-1)+j]*Ygotique0;
                        # Mg4=A^(1/2)*M0*diagm(sqrt.(vec(c./(co*(ones(m*k,1)+δe)))));
                        # Mg2=sum(kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,i]*e_ij[:,m*(i-1)+j]',sqrt(δ_tilde[m*(i-1)+j])*M[:,m*(i-1)+j]) for i=1:k,j=1:m)
                        # Mg3=sum(kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,i]*((c[m*(i-1)+2]/cc[i])*sqrt(δ_tilde1[i])*e_ij[:,m*(i-1)+1]'-(c[m*(i-1)+1]/cc[i])*sqrt(δ_tilde1[i])*e_ij[:,m*(i-1)+2]'),
                        # Δ2[:,i]) for i=1:k)
                        # Mg_t=sum(kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,i]*h[i]',Δ2[:,i]) for i=1:k)
                        # Qtilde01=kron(inv(Matrix{Float64}(I, k, k)+(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*diagm(vec(δ_tilde1))*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)),Matrix{Float64}(I, p, p))
                        # test=Mg'*Qtilde0*V[:,:,m*(i-1)+j]*Qtilde0*Mg
                        # KAPPAf=Dt*test2/(Matrix{Float64}(I, k, k)-Dt*test2)
                        # test1=sum(kron(sqrt(δ_tilde1[ip])*h[ip]*e_i[:,ip]'*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*inv(Matrix{Float64}(I, k, k)+(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*diagm(vec(δ_tilde1))*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2))*
                        # (diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*(e_i[:,i]*e_i[:,i]'+LUM3[i]*e_i[:,i]*e_i[:,i]')*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*inv(Matrix{Float64}(I, k, k)+(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*diagm(vec(δ_tilde1))*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2))*
                        # (diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,jp]*h[jp]'*sqrt(δ_tilde1[jp]),Δμ[ip,jp]) for ip=1:k,jp=1:k)
                end
        end
        # for i=1:k
        #         V[:,:,i]=diagm(vec(kron(κ[i,:],ones(k,1))))+kron(Agotique*((1/δ_tilde1[i])*diagm(vec(e_i[:,i]*(1+LUM3[i]))))*Agotique,ones(k,1)*ones(1,k)).*MM;
        #         σ_th[i]=Ygotique0'*diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,i]*Γ)*diagm(vec(δ_tilde))^(1/2)*Ygotique0;
        # end
        ##################TO DELET###################################
        #############################################
        #Calcul de l'erreur empirique et théorique
        pred_source=zeros(size(X_test)[2],1);pred_target=zeros(sum(n_test[3:4]),1);
        threshold_emp=(mean(gx_s[1:n_test[1]])+mean(gx_s[1+n_test[1]:end]))/2;
        pred_source[gx_s.<threshold_emp*ones(size(X_test)[2],1)].=-1;pred_source[gx_s.>threshold_emp*ones(size(X_test)[2],1)].=1;
        threshold_emp_target=(mean(gx_t[1:n_test[3]])+mean(gx_t[1+n_test[3]:end]))/2;
        pred_target[gx_t.<threshold_emp_target*ones(sum(n_test[3:4]),1)].=-1;pred_target[gx_t.>threshold_emp_target*ones(sum(n_test[3:4]),1)].=1;
        error_source_emp=sum(pred_source.!=y_test)./size(X_test)[2];
        error_target_emp=sum(pred_target.!=y_test1)./sum(n_test[3:4]);
        error_source_th=(n_test[1]/size(X_test)[2])*0.5*erfc((μ_th[1]-μ_th[2])./(2*sqrt(2)*sqrt(σ_th[1])))+(n_test[2]/size(X_test)[2])*0.5*erfc((μ_th[1]-μ_th[2])./(2*sqrt(2)*sqrt(σ_th[1])));
        error_target_th=(n_test[3]/sum(n_test[3:4]))*0.5*erfc((μ_th[3]-μ_th[4])./(2*sqrt(2)*sqrt(σ_th[2])))+(n_test[4]/sum(n_test[3:4]))*0.5*erfc((μ_th[3]-μ_th[4])./(2*sqrt(2)*sqrt(σ_th[2])));
        # A faire l'optimization par rapport à y.
        e_ij=Matrix{Float64}(I, k*m, k*m);
        Ze=zeros(m*k,m*k);task=1;
        rg_k=1+m*(task-1):2+m*(task-1);
        Ze[rg_k,rg_k]=[(1-ns[m*(task-1)+1]/n1) -ns[m*(task-1)+2]/n1;-ns[m*(task-1)+1]/n1 (1-ns[m*(task-1)+2]/n1)];
        rg_t=1+m*(k-1):2+m*(k-1);
        Ze[rg_t,rg_t]=[(1-ns[m*(k-1)+1]/n2) -ns[m*(k-1)+2]/n2; (-ns[m*(k-1)+1]/n2) (1-ns[m*(k-1)+2]/n2)];
        #y_tilde_opt0=diagm(vec(δ_tilde))^(-1/2)*inv(Γ)*inv(V[:,:,2])*(kron(Agotique,ones(k,1)*ones(1,k)).*MM)*diagm(vec(δ_tilde))^(-1/2)*(e_ij[:,3]-e_ij[:,4]);
        # res = optimize(x->(-(x'*(Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2))*(e_ij[:,3]-e_ij[:,4]))^2/
        # (8*x'*diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,2]*Γ)*diagm(vec(δ_tilde))^(1/2)*x)), Ze*[1.0;-1.0;1.0;-1.0])
        #y_tilde_opt0=Optim.minimizer(res);
        # y_tilde_opt0=inv(diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,2]*Γ)*diagm(vec(δ_tilde))^(1/2))*
        # (Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(1/2)*Γ*diagm(vec(δ_tilde))^(-1/2))*(e_ij[:,3]-e_ij[:,4])
        y_tilde_opt0=inv(Mat[:,:,3])*
        (Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(1/2)*Γ*diagm(vec(δ_tilde))^(-1/2))*(e_ij[:,3]-e_ij[:,4])
        # x1=Ze*[1.0;-1.0;1.0;-1.0];
        # x2=y_tilde_opt0;
        # y_tilde_opt02=diagm(vec(δ_tilde))^(-1/2)*(inv(Γ)*inv(V[:,:,2])*inv(Γ))*diagm(vec(δ_tilde))^(-1/2)*
        # (Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2))*(e_ij[:,3]-e_ij[:,4])
        # err2=0.5*erfc(sqrt(-res(y_tilde_opt01)));
        # err=0.5*erfc(sqrt(-Optim.minimum(res)));
        y_tilde_opt=pinv(Ze)*y_tilde_opt0;
        #y_tilde_opt=Ze\y_tilde_opt0;
        y_tilde_opt0=Ze*y_tilde_opt;
        # optim1=(x1'*(Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2))*(e_ij[:,3]-e_ij[:,4]))^2/(8*x1'*diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,2]*Γ)*diagm(vec(δ_tilde))^(1/2)*x1)
        # optim2=(x2'*(Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2))*(e_ij[:,3]-e_ij[:,4]))^2/(8*x2'*diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,2]*Γ)*diagm(vec(δ_tilde))^(1/2)*x2)
        #y_tilde_opt=pinv(Ze,rtol=1e-12)*y_tilde_opt0;

        #Calcul empirique
        y_opt=J*y_tilde_opt;
        ##################################
        S1=zeros(k*p,k*p,m*k);
        d=zeros(k*m,1);
        Tbar=zeros(m*k,m*k);
        Tg=zeros(m*k,m*k);
        σ_th1=zeros(m*k,1);
        # for i=1:k
        #         e_i=zeros(k,1);e_i[i]=1;
        #         for j=1:m
        #                 S1[:,:,m*(i-1)+j]=kron(e_i*e_i',Σ[:,:,m*(i-1)+j]);
        #                 d[m*(i-1)+j]=ns[m*(i-1)+j]./(k*p*(1+δe[m*(i-1)+j])^2)
        #                 for ip=1:k
        #                         for jp=1:m
        #                                 Tbar[m*(i-1)+j,m*(ip-1)+jp]=(1/(k*p))*tr(C[:,:,m*(ip-1)+jp]*Qbar*A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2)*Qbar);
        #                                 Tg[m*(i-1)+j,m*(ip-1)+jp]=(1/(k*p))*tr(C[:,:,m*(i-1)+j]*Qbar*C[:,:,m*(ip-1)+jp]*Qbar);
        #                         end
        #                 end
        #         end
        # end
        # D=diagm(vec(d));
        # T=Tbar/(Matrix{Float64}(I, m*k, m*k)-D*Tg);
        # κ4=zeros(k*m,k*m);
        # V=zeros(k*p,k*p,m*k);
        # for i=1:k
        #         for j=1:m
        #                 for ip=1:k
        #                         for jp=1:m
        #                                 κ4[m*(i-1)+j,m*(ip-1)+jp]=d[m*(ip-1)+jp]*T[m*(i-1)+j,m*(ip-1)+jp]/δ_tilde[m*(ip-1)+jp];
        #                         end
        #                 end
        #                 # LUM=(Tbar/(Matrix{Float64}(I, m*k, m*k)-D*Tg))*D;
        #                 # LUM_test=(test2/(Matrix{Float64}(I, k, k)-Dt*test2))*Dt
        #                 # LUM2=[LUM[1,1]+LUM[1,2] LUM[1,3]+LUM[1,4];LUM[3,1]+LUM[3,2] LUM[3,3]+LUM[3,4]];
        #                 # LUM3=[LUM2[1,1]+LUM2[1,2];LUM2[2,1]+LUM2[2,2]];
        #                 Sec=sum(δ_tilde[m*(ip-1)+jp]*κ4[m*(i-1)+j,m*(ip-1)+jp]*A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2) for ip=1:k,jp=1:m);
        #                 # Sec2=LUM3[i]*A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2);
        #                 # Ve=kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*(e_i[:,i]*e_i[:,i]'+e_i[:,i]*e_i[:,i]'*LUM3[i])*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2),Matrix{Float64}(I, p, p))
        #                 V[:,:,m*(i-1)+j]=A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2)+Sec;
        #                 σ_th1[m*(i-1)+j]=y_tilde_opt0'*diagm(vec(δ_tilde))^(1/2)*(Γ*diagm(vec(κ4[m*(i-1)+j,:]))*Γ+Γ*Mg'*Qtilde0*V[:,:,m*(i-1)+j]*Qtilde0*Mg*Γ)*diagm(vec(δ_tilde))^(1/2)*y_tilde_opt0;
        #                 # Mg4=A^(1/2)*M0*diagm(sqrt.(vec(c./(co*(ones(m*k,1)+δe)))));
        #                 # Mg2=sum(kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,i]*e_ij[:,m*(i-1)+j]',sqrt(δ_tilde[m*(i-1)+j])*M[:,m*(i-1)+j]) for i=1:k,j=1:m)
        #                 # Mg3=sum(kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,i]*((c[m*(i-1)+2]/cc[i])*sqrt(δ_tilde1[i])*e_ij[:,m*(i-1)+1]'-(c[m*(i-1)+1]/cc[i])*sqrt(δ_tilde1[i])*e_ij[:,m*(i-1)+2]'),
        #                 # Δ2[:,i]) for i=1:k)
        #                 # Mg_t=sum(kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,i]*h[i]',Δ2[:,i]) for i=1:k)
        #                 # Qtilde01=kron(inv(Matrix{Float64}(I, k, k)+(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*diagm(vec(δ_tilde1))*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)),Matrix{Float64}(I, p, p))
        #                 # test=Mg'*Qtilde0*V[:,:,m*(i-1)+j]*Qtilde0*Mg
        #                 # KAPPAf=Dt*test2/(Matrix{Float64}(I, k, k)-Dt*test2)
        #                 # test1=sum(kron(sqrt(δ_tilde1[ip])*h[ip]*e_i[:,ip]'*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*inv(Matrix{Float64}(I, k, k)+(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*diagm(vec(δ_tilde1))*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2))*
        #                 # (diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*(e_i[:,i]*e_i[:,i]'+LUM3[i]*e_i[:,i]*e_i[:,i]')*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*inv(Matrix{Float64}(I, k, k)+(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*diagm(vec(δ_tilde1))*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2))*
        #                 # (diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,jp]*h[jp]'*sqrt(δ_tilde1[jp]),Δμ[ip,jp]) for ip=1:k,jp=1:k)
        #         end
        # end
        #######################
        b_opt=(P'*Q*P)\(P'*Q*y_opt);
        gx_s_opt=(1/(k*p))*kron(e_s,X_test)'*A*Z*Q*(y_opt-P*b_opt)+b_opt[1]*ones(size(X_test)[2],1);
        gx_t_opt=(1/(k*p))*kron(e_t,X_test1)'*A*Z*Q*(y_opt-P*b_opt)+b_opt[2]*ones(sum(n_test[3:4]),1);
        # gx_t_opt2=(1/(k*p))*kron(e_t,X_test1)'*A^(1/2)*Qtilde*A^(1/2)*Z*(y_opt-P*b_opt)+b_opt[2]*ones(sum(n_test[3:4]),1);
        # Qtilde=inv((1/(k*p))*A^(1/2)*Z*Z'*A^(1/2)+Matrix{Float64}(I, k*p, k*p));
        #  gx_t2_opt=(1/(k*p))*kron(e_t,X_test1)'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)+b_opt[2]*ones(sum(n_test[3:4]),1);
        #  gx_t22_opt=(1/(k*p))*kron(e_t,X_test1)'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)+b_opt[2]*ones(sum(n_test[3:4]),1);
        #  gx_t2221_opt=(1/(k*p))*kron(e_t,mean(X_test1[:,1:n_test[1]],dims=2))'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)+[b_opt[2]];
        #  gx_t222_opt=(1/(k*p))*M0'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)+[b_opt[1];b_opt[1];b_opt[2];b_opt[2]];
        #  gx_t222_opt=(1/(k*p))*M0'*A^(1/2)*(Qtilde0)*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)-
        #  (1/(k*p))*M0'*A^(1/2)*(Qtilde0*Mg*inv(Matrix{Float64}(I, k*m, k*m)+Mg'*Qtilde0*Mg)*Mg'*Qtilde0)*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)+[b_opt[1];b_opt[1];b_opt[2];b_opt[2]];
        #  gth=Ygotique_opt-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2)*Ygotique0_opt;
        μ_emp_opt=zeros(m*k,1);
        σ_emp_opt=zeros(m*k,1);
        σ_th_opt=zeros(k,1);
        μ_emp_opt[1]=mean(gx_s_opt[1:n_test[1]]);
        μ_emp_opt[2]=mean(gx_s_opt[1+n_test[1]:n_test[1]+n_test[2]]);
        μ_emp_opt[3]=mean(gx_t_opt[1:n_test[3]]);
        μ_emp_opt[4]=mean(gx_t_opt[n_test[3]+1:n_test[3]+n_test[4]]);
        σ_emp_opt[1]=std(gx_s_opt[1:n_test[1]]).^2;
        σ_emp_opt[2]=std(gx_s_opt[1+n_test[1]:n_test[1]+n_test[2]]).^2;
        σ_emp_opt[3]=std(gx_t_opt[1:n_test[3]]).^2;
        σ_emp_opt[4]=std(gx_t_opt[n_test[3]+1:end]).^2;
        #Calcul empirique error
        pred_source_opt=zeros(size(X_test)[2],1);pred_target_opt=zeros(sum(n_test[3:4]),1);
        threshold_emp_opt=(mean(gx_s_opt[1:n_test[1]])+mean(gx_s_opt[1+n_test[1]:end]))/2;
        pred_source_opt[gx_s_opt.<threshold_emp_opt*ones(size(X_test)[2],1)].=-1;pred_source_opt[gx_s_opt.>threshold_emp_opt*ones(size(X_test)[2],1)].=1;
        threshold_emp_target_opt=(mean(gx_t_opt[1:n_test[3]])+mean(gx_t_opt[1+n_test[3]:end]))/2;
        pred_target_opt[gx_t_opt.<threshold_emp_target_opt*ones(sum(n_test[3:4]),1)].=-1;pred_target_opt[gx_t_opt.>threshold_emp_target_opt*ones(sum(n_test[3:4]),1)].=1;
        error_source_emp_opt=sum(pred_source_opt.!=y_test)./size(X_test)[2];
        error_target_emp_opt=sum(pred_target_opt.!=y_test1)./sum(n_test[3:4]);
        #Calcul théorique des erreurs
        Ygotique_opt=y_tilde_opt;Ygotique0_opt=y_tilde_opt0;
        μ_th_opt=Ygotique_opt-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2)*Ygotique0_opt;
        σ_th_opt=zeros(m*k,1);
        #V=zeros(k*m,k*m,k)
        for i=1:k
                for j=1:m
                # V[:,:,i]=diagm(vec(kron(κ[i,:],ones(k,1))))+kron(Agotique*((1/δ_tilde1[i])*diagm(vec(e_i[:,i]*(1+LUM3[i]))))*Agotique,ones(k,1)*ones(1,k)).*MM;
                        σ_th_opt[m*(i-1)+j]=Ygotique0_opt'*Mat[:,:,m*(i-1)+j]*Ygotique0_opt;
                end
        end
        # for i=1:k
        #         V[:,:,i]=diagm(vec(kron(κ[i,:],ones(k,1))))+kron(Agotique*((1/δ_tilde1[i])*diagm(vec(e_i[:,i]*(1+LUM3[i]))))*Agotique,ones(k,1)*ones(1,k)).*MM;
        #         σ_th_opt[i]=Ygotique0_opt'*diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,i]*Γ)*diagm(vec(δ_tilde))^(1/2)*Ygotique0_opt;
        # end
        error_source_th_opt=(n_test[1]/size(X_test)[2])*0.5*erfc((μ_th_opt[1]-μ_th_opt[2])./(2*sqrt(2)*sqrt(σ_th_opt[1])))+(n_test[2]/size(X_test)[2])*0.5*erfc((μ_th_opt[1]-μ_th_opt[2])./(2*sqrt(2)*sqrt(σ_th_opt[1])));
        error_target_th_opt=(n_test[3]/sum(n_test[3:4]))*0.5*erfc((μ_th_opt[3]-μ_th_opt[4])./(2*sqrt(2)*sqrt(σ_th_opt[2])))+(n_test[4]/sum(n_test[3:4]))*0.5*erfc((μ_th_opt[3]-μ_th_opt[4])./(2*sqrt(2)*sqrt(σ_th_opt[2])));
        # p1=histogram(gx_s[n_test[1]+1:end],normalize = true,alpha=0.5,bins=100);
        # p1=histogram!(gx_s[1:n_test[1]],normalize = true,alpha=0.5,bins=100);
        # p1=plot!(Normal(μ_th[1],sqrt(abs(σ_th[1]))));
        # p1=plot!(Normal(μ_th[2],sqrt(abs(σ_th[1]))));
        # display(p1)
        # p2=histogram(gx_t[n_test[3]+1:end],normalize = true,alpha=0.5,bins=100);
        # p2=histogram!(gx_t[1:n_test[3]],normalize = true,alpha=0.5,bins=100);
        # p2=plot!(Normal(μ_th[3],sqrt(abs(σ_th[3]))));
        # p2=plot!(Normal(μ_th[4],sqrt(abs(σ_th[3]))));
        # display(p2)
        # p3=histogram(gx_s_opt[n_test[1]+1:end],normalize = true,alpha=0.5,bins=100);
        # p3=histogram!(gx_s_opt[1:n_test[1]],normalize = true,alpha=0.5,bins=100);
        # p3=plot!(Normal(μ_th_opt[1],sqrt(abs(σ_th_opt[1]))));
        # p3=plot!(Normal(μ_th_opt[2],sqrt(abs(σ_th_opt[1]))));
        # display(p3)
        # p4=histogram(gx_t_opt[n_test[3]+1:end],normalize = true,alpha=0.5,bins=100);
        # p4=histogram!(gx_t_opt[1:n_test[3]],normalize = true,alpha=0.5,bins=100);
        # p4=plot!(Normal(μ_th_opt[3],sqrt(abs(σ_th_opt[3]))));
        # p4=plot!(Normal(μ_th_opt[4],sqrt(abs(σ_th_opt[3]))));
        # display(p4)
        return gx_s,gx_t,μ_th,μ_emp,σ_th,σ_emp,error_source_emp,error_target_emp,error_source_th,error_target_th,
        gx_s_opt,gx_t_opt,μ_th_opt,μ_emp_opt,σ_th_opt,σ_emp_opt,error_source_emp_opt,error_target_emp_opt,error_source_th_opt,error_target_th_opt
end
function RMTMTLLSSVM_PFA(Sfts,Slabels,Tfts,Tlabels,λ,γ,X_test,X_test1,ns,n_test,eta)
        #Define parameters
        p,nul=size(Tfts);
        y_test=[ones(n_test[1],1);-ones(n_test[2],1)];
        y_test1=[ones(n_test[3],1);-ones(n_test[4],1)];
        #k=numel(X1)+1;
        k=2;
        m=2
        n=sum(ns);
        c=ns/sum(ns);
        co=k*p/n;
        n1=sum(ns[1:2]);n2=sum(ns[3:4]);
        P=zeros(n,k);
        P[1:n1,1]=ones(n1,1);P[n1+1:end,2]=ones(n2,1);
        A=kron(diagm(γ)+λ*ones(k,1)*ones(1,k),Matrix{Float64}(I, p, p));
        λ=λ./norm(A);γ=γ./norm(A);
        A=kron(diagm(γ)+λ*ones(k,1)*ones(1,k),Matrix{Float64}(I, p, p));
        #Compute statististics of the data.
        #Centering and scaling of the data;
        Mi,Σi=compute_statistics(Sfts,Tfts,ns);
        Sfts_c=(Sfts*(Matrix{Float64}(I, n1, n1)-(1/n1)*ones(n1,1)*ones(1,n1)));
        cons1=1;
        # cons1=((1/(n1*p))*tr(Sfts_c*Sfts_c'));
        Sfts_cs=Sfts_c./cons1;
        Tfts_c=(Tfts*(Matrix{Float64}(I, n2, n2)-(1/n2)*ones(n2,1)*ones(1,n2)));
        cons2=1;
        # cons2=((1/(n2*p))*tr(Tfts_c*Tfts_c'));
        Tfts_cs=Tfts_c./cons2;
        Mo,Σ=compute_statistics(Sfts_cs,Tfts_cs,ns);
        # M_c_pop_s=sum((ns[j]./n1)*Mo[:,j] for j=1:m)
        # M_c_pop_t=sum((ns[m+j]./n2)*Mo[:,m+j] for j=1:m)
        # M_source_c=Mo[:,1:2]-M_c_pop_s*ones(1,2);
        # M_target_c=Mo[:,3:4]-M_c_pop_t*ones(1,2);
        # M_source_cs=(Mo[:,1:2]-M_c_pop_s*ones(1,2))/((1/(n1*p))*tr(Sfts_c*Sfts_c'));
        # M_target_cs=(Mo[:,3:4]-M_c_pop_t*ones(1,2))/((1/(n2*p))*tr(Tfts_c*Tfts_c'));
        # M=[M_source_cs M_target_cs];
        # M_source=(Mo[:,1]-Mo[:,2])/((1/(n1*p))*tr(Sfts_c*Sfts_c'));
        # M_target=(Mo[:,3]-Mo[:,4])/((1/(n2*p))*tr(Tfts_c*Tfts_c'));
        Σ[:,:,1]=Matrix{Float64}(I, p, p);
        Σ[:,:,2]=Matrix{Float64}(I, p, p);
        Σ[:,:,3]=Matrix{Float64}(I, p, p);
        Σ[:,:,4]=Matrix{Float64}(I, p, p);
        M_cens=sum((ns[j]./n1)*Mi[:,j] for j=1:m);
        X_test=(X_test-M_cens*ones(1,size(X_test)[2]))./cons1;
        M_cent=sum((ns[m*(k-1)+j]./n2)*Mi[:,m*(k-1)+j] for j=1:m)
        X_test1=(X_test1-M_cent*ones(1,sum(n_test[3:4])))./cons2;
        Z=[Sfts_cs zeros(p,n2);zeros(p,n1) Tfts_cs];
        Q=inv((1/(k*p))*Z'*A*Z+Matrix{Float64}(I, n, n));
        y=[Slabels;Tlabels];
        b=(P'*Q*P)\(P'*Q*y);
        # M0=zeros(k*p,m*k);
        # for i=1:k
        #         e_i=zeros(k,1);e_i[i]=1;
        #         for j=1:m
        #                 M0[:,m*(i-1)+j]=kron(e_i,M[:,m*(i-1)+j]);
        #         end
        # end
        e_s=zeros(k,1);e_t=zeros(k,1);
        e_s[1]=1;e_t[2]=1;
        gx_s=(1/(k*p))*kron(e_s,X_test)'*A*Z*Q*(y-P*b)+b[1]*ones(size(X_test)[2],1);
        gx_t=(1/(k*p))*kron(e_t,X_test1)'*A*Z*Q*(y-P*b)+b[2]*ones(sum(n_test[3:4]),1);
        # gx_t2=(1/(k*p))*kron(e_t,X_test1)'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y-P*b)+b[2]*ones(sum(n_test[3:4]),1);
        # gx_t22=(1/(k*p))*kron(e_t,X_test1)'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y-P*b)+b[2]*ones(sum(n_test[3:4]),1);
        # gx_t222=(1/(k*p))*M0[:,3:4]'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y-P*b)+[b[2];b[2]];
        #gx_s2=(1/(k*p))*M0[:,1:2]'*A*Z*Q*(y-P*b)+[b[1];b[1]];
        #gx_t2=(1/(k*p))*M0[:,3:4]'*A*Z*Q*(y-P*b)+[b[2];b[2]];
        μ_emp=zeros(m*k,1);
        σ_emp=zeros(m*k,1);
        σ_th=zeros(k,1);
        μ_emp[1]=mean(gx_s[1:n_test[1]]);
        μ_emp[2]=mean(gx_s[1+n_test[1]:n_test[1]+n_test[2]]);
        μ_emp[3]=mean(gx_t[1:n_test[3]]);
        μ_emp[4]=mean(gx_t[n_test[3]+1:n_test[3]+n_test[4]]);
        σ_emp[1]=std(gx_s[1:n_test[1]]).^2;
        σ_emp[2]=std(gx_s[1+n_test[1]:n_test[1]+n_test[2]]).^2;
        σ_emp[3]=std(gx_t[1:n_test[3]]).^2;
        σ_emp[4]=std(gx_t[n_test[3]+1:end]).^2;
        #Calcul covariance généralisé
        C=zeros(k*p,k*p,m*k);
        for i=1:k
                e_i=zeros(k,1);e_i[i]=1;
                for j=1:m
                        C[:,:,m*(i-1)+j]=A^(1/2)*kron(e_i*e_i',Σ[:,:,m*(i-1)+j]+Mo[:,m*(i-1)+j]*Mo[:,m*(i-1)+j]')*A^(1/2);
                end
        end
        #Calcul du delta
        #δ,Qbar=delta_function(C,k,m,p,ns);
        δe,Qbar=delta_function(C,k,m,p,ns,λ,γ);
        M0=zeros(k*p,m*k);
        for i=1:k
                e_i=zeros(k,1);e_i[i]=1;
                for j=1:m
                        M0[:,m*(i-1)+j]=kron(e_i,Mo[:,m*(i-1)+j]);
                end
        end
        M_δ=M0*diagm(vec(ones(m*k,1)./(ones(m*k,1)+δe)));
        Mg=A^(1/2)*M0*diagm(sqrt.(vec(c./(co*(ones(m*k,1)+δe)))));
        invQtilde0=zeros(k*p,k*p);
        for i=1:k
                e_i=zeros(k,1);e_i[i]=1;
                for j=1:m
                        invQtilde0=invQtilde0+kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i*e_i'*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2),(c[m*(i-1)+j]./(co*(1+δe[m*(i-1)+j])))*Σ[:,:,m*(i-1)+j]);
                end
        end
        Qtilde0=inv(invQtilde0+Matrix{Float64}(I, k*p, k*p));
        δ=delta_function_identity(k,p,ns,λ,γ);
        cb=zeros(2,k);
        for i=1:k
                cb[:,i]=sqrt(c[m*(i-1)+1]./(sum(c[m*(i-1)+1:m*(i-1)+2])))*sqrt(c[m*(i-1)+2]./(sum(c[m*(i-1)+1:m*(i-1)+2])))*
                [sqrt(c[m*(i-1)+2]./(sum(c[m*(i-1)+1:m*(i-1)+2])));-sqrt(c[m*(i-1)+1]./(sum(c[m*(i-1)+1:m*(i-1)+2])))];
        end
        J=zeros(n,m*k);
         J[1:ns[1],1]=ones(ns[1],1);J[ns[1]+1:ns[1]+ns[2],2]=ones(ns[2],1);J[n1+1:n1+ns[3],3]=ones(ns[3],1);J[n1+ns[3]+1:end,4]=ones(ns[4],1);
        e_i=Matrix{Float64}(I, k, k);
        # J11=zeros(n1,1);J12=zeros(n1,1);
        # J21=zeros(n2,1);J22=zeros(n2,1);
        # J11[1:ns[1],:]=ones(ns[1],1);J12[ns[1]+1:end,:]=ones(ns[2],1);
        # J21[1:ns[3],:]=ones(ns[3],1);J22[ns[3]+1:end,:]=ones(ns[4],1);
        # cardS11=ns[1];cardS12=ns[2];cardS21=ns[3];cardS22=ns[4];
        Δμ=zeros(k,k);
        nd=[n1;n2];
        cardS11=convert(Int,floor(ns[2*(1-1)+1]/2));cardS1p1=convert(Int,ns[2*(1-1)+1]-cardS11);cardS12=convert.(Int,floor(ns[2*(1-1)+2]/2));cardS1p2=convert.(Int,ns[2*(1-1)+2]-cardS12);
        cardS21=convert.(Int,floor(ns[2*(2-1)+1]/2));cardS2p1=convert.(Int,ns[2*(2-1)+1]-cardS21);cardS22=convert.(Int,floor(ns[2*(2-1)+2]/2));cardS2p2=convert.(Int,ns[2*(2-1)+2]-cardS22);
        J_11=zeros(nd[1],1);J_12=zeros(nd[1],1);J_1p1=zeros(nd[1],1);J_1p2=zeros(nd[1],1);
        J_21=zeros(nd[2],1);J_22=zeros(nd[2],1);J_2p1=zeros(nd[2],1);J_2p2=zeros(nd[2],1);
        J_11[1:cardS11].=1;J_1p1[cardS11+1:ns[2*(1-1)+1]].=1;J_12[ns[2*(1-1)+1]+1:ns[2*(1-1)+1]+cardS12].=1;
        J_21[1:cardS21].=1;J_2p1[cardS21+1:ns[2*(2-1)+1]].=1;J_22[ns[2*(2-1)+1]+1:ns[2*(2-1)+1]+cardS22].=1;
        J_1p2[ns[2*(1-1)+1]+cardS12+1:end].=1;
        J_2p2[ns[2*(2-1)+1]+cardS22+1:end].=1;
        Δμ[1,1]=((J_11./cardS11-J_12./cardS12)'*Sfts_cs'*Sfts_cs*(J_1p1./cardS1p1-J_1p2./cardS1p2))[1];
        Δμ[2,2]=((J_21./cardS21-J_22./cardS22)'*Tfts_cs'*Tfts_cs*(J_2p1./cardS2p1-J_2p2./cardS2p2))[1];
        cardS11=ns[2*(1-1)+1];cardS12=ns[2*(1-1)+2];cardS21=ns[2*(2-1)+1];cardS22=ns[2*(2-1)+2];
        J_11=zeros(nd[1],1);J_12=zeros(nd[1],1);J_21=zeros(nd[2],1);J_22=zeros(nd[2],1);
        J_11[1:cardS11].=1;J_21[1:cardS21].=1;J_12[cardS11+1:end].=1;J_22[cardS21+1:end].=1;
        Δμ[1,2]=((J_11./cardS11-J_12./cardS12)'*Sfts_cs'*Tfts_cs*(J_21./cardS21-J_22./cardS22))[1];
        Δμ[2,1]=((J_21./cardS21-J_22./cardS22)'*Tfts_cs'*Sfts_cs*(J_11./cardS11-J_12./cardS12))[1];
        #####Test estimation équivalent déterministe
        # Δμ2=zeros(k,k);
        # Δμ2[1,1]=M_source'*M_source;Δμ2[1,2]=M_source'*M_target;Δμ2[2,1]=M_target'*M_source;
        # Δμ2[2,2]=M_target'*M_target;
        #Δμ=Δμ2;

        Δ=zeros(p,2)
        Δ[:,1]=(Sfts_cs*(J_11./cardS11-J_12./cardS12));
        Δ[:,2]=(Tfts_cs*(J_21./cardS21-J_22./cardS22));
        Δ[:,1]=(Mo[:,1]-Mo[:,2])./((1/(n1*p))*tr(Sfts_c*Sfts_c'));
        Δ[:,2]=(Mo[:,3]-Mo[:,4])./((1/(n2*p))*tr(Tfts_c*Tfts_c'));
        Δ2=zeros(p,2);
        Δ2[:,1]=(Mo[:,1]-Mo[:,2])
        Δ2[:,2]=(Mo[:,3]-Mo[:,4])
        e_j=Matrix{Float64}(I, k*m, k*m);
        c11=c[2*(1-1)+1];c12=c[2*(1-1)+2];c21=c[2*(2-1)+1];c22=c[2*(2-1)+2];
        c1=c11+c12;c2=c21+c22;
        cc=[c1;c2];
        δ_tilde1=zeros(k,1);
        δ_tilde1[1]=c1/(co*(1+δ[1]));δ_tilde1[2]=c2/(co*(1+δ[2]));
        δ_tilde=c./(co*(ones(m*k,1)+kron(δ,ones(m,1))));
        h=[(1/sqrt(δ_tilde1[i]))*(1/cc[i])*sqrt(c[m*(i-1)+1]*c[m*(i-1)+2]./(co*(1+δ[i])))*(sqrt(c[m*(i-1)+2])*e_j[:,m*(i-1)+1]-
        sqrt(c[m*(i-1)+1])*e_j[:,m*(i-1)+2]) for i=1:k];
        #Mg2=sum(kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,i]*e_ij[:,m*(i-1)+j]',sqrt(δ_tilde[m*(i-1)+j])*M[:,m*(i-1)+j]) for i=1:k,j=1:m)
        # Md=[M_source M_target];
        # Mg_t=sum(kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,i]*h[i]',Md[:,i]) for i=1:k)
        Agotique=inv(Matrix{Float64}(I, k, k)+diagm(vec(δ_tilde1))^(-1/2)*inv((diagm(γ)+λ*ones(k,1)*ones(1,k)))*diagm(vec(δ_tilde1))^(-1/2))
        MM=sum(Δμ[i,j]*h[i]*h[j]' for i=1:k,j=1:k);
        Γ=inv(Matrix{Float64}(I, m*k, m*k)+kron(Agotique,ones(k,1)*ones(1,k)).*MM);
        Γ2=inv(Matrix{Float64}(I, m*k, m*k)+Mg'*Qtilde0*Mg);
        #yo=[1-b[1];-1-b[1];1-b[2];-1-b[2]];
        #gx_s1=(1/(k*p))*kron(e_s,X_test)'*A*Z*Q*(y-P*b)+b[1]*ones(sum(n_test[1:2]),1);
        Ygotique=[1;-1;1;-1];Ygotique0=[1-b[1];-1-b[1];1-b[2];-1-b[2]];
        e_ij=Matrix{Float64}(I, k*m, k*m);
        # (e_ij[:,3]-e_ij[:,4])'*(Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2))*Ygotique
        # (x'*(Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(1/2)*Γ*diagm(vec(δ_tilde))^(-1/2))*(e_ij[:,3]-e_ij[:,4]))
        μ_th=Ygotique-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2)*Ygotique0;
        #println(μ_th[3]-μ_th[4])
        Matm=(Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(1/2)*Γ*diagm(vec(δ_tilde))^(-1/2))*(e_ij[:,3]-e_ij[:,4]);
        #println(Ygotique0'*Matm)
        Dt=diagm(vec([cc[i]./(co*(1+δ[i])^2) for i=1:k]));
        test2=(1/k)*(diagm(vec(δ_tilde1))^(-1/2)*Agotique*diagm(vec(δ_tilde1))^(-1/2)).*(diagm(vec(δ_tilde1))^(-1/2)*Agotique*diagm(vec(δ_tilde1))^(-1/2))
        K=Dt*test2/(Matrix{Float64}(I, k, k)-Dt*test2)
        #KAPPA=diagm(vec(δ_tilde1))^(-1)*K;
        KAPPA=K*diagm(vec(δ_tilde1));
        LUM_test=(test2/(Matrix{Float64}(I, k, k)-Dt*test2))*Dt
        LUM3=sum(LUM_test,dims=2);
        #κ=K*diagm(vec(δ_tilde1))^(-1);
        κ= transpose((co)*diagm(vec(cc))^(-1)*diagm(vec(δ_tilde1))*test2/(Matrix{Float64}(I, k, k)-Dt*test2))
        V=zeros(k*m,k*m,k);
        σ_th=zeros(m*k,1);
        S1=zeros(k*p,k*p,m*k);
        d=zeros(k*m,1);
        Tbar=zeros(m*k,m*k);
        Tg=zeros(m*k,m*k);
        σ_th1=zeros(m*k,1);
        for i=1:k
                e_i=zeros(k,1);e_i[i]=1;
                for j=1:m
                        S1[:,:,m*(i-1)+j]=kron(e_i*e_i',Σ[:,:,m*(i-1)+j]);
                        d[m*(i-1)+j]=ns[m*(i-1)+j]./(k*p*(1+δe[m*(i-1)+j])^2)
                        for ip=1:k
                                for jp=1:m
                                        Tbar[m*(i-1)+j,m*(ip-1)+jp]=(1/(k*p))*tr(C[:,:,m*(ip-1)+jp]*Qbar*A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2)*Qbar);
                                        Tg[m*(i-1)+j,m*(ip-1)+jp]=(1/(k*p))*tr(C[:,:,m*(i-1)+j]*Qbar*C[:,:,m*(ip-1)+jp]*Qbar);
                                end
                        end
                end
        end
        D=diagm(vec(d));
        T=Tbar/(Matrix{Float64}(I, m*k, m*k)-D*Tg);
        κ4=zeros(k*m,k*m);
        V=zeros(k*p,k*p,m*k);
        Mat=zeros(m*k,m*k,m*k);
        for i=1:k
                for j=1:m
                        for ip=1:k
                                for jp=1:m
                                        κ4[m*(i-1)+j,m*(ip-1)+jp]=d[m*(ip-1)+jp]*T[m*(i-1)+j,m*(ip-1)+jp]/δ_tilde[m*(ip-1)+jp];
                                end
                        end
                        # LUM=(Tbar/(Matrix{Float64}(I, m*k, m*k)-D*Tg))*D;
                        # LUM_test=(test2/(Matrix{Float64}(I, k, k)-Dt*test2))*Dt
                        # LUM2=[LUM[1,1]+LUM[1,2] LUM[1,3]+LUM[1,4];LUM[3,1]+LUM[3,2] LUM[3,3]+LUM[3,4]];
                        # LUM3=[LUM2[1,1]+LUM2[1,2];LUM2[2,1]+LUM2[2,2]];
                        Sec=sum(δ_tilde[m*(ip-1)+jp]*κ4[m*(i-1)+j,m*(ip-1)+jp]*A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2) for ip=1:k,jp=1:m);
                        # Sec2=LUM3[i]*A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2);
                        # Ve=kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*(e_i[:,i]*e_i[:,i]'+e_i[:,i]*e_i[:,i]'*LUM3[i])*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2),Matrix{Float64}(I, p, p))
                        V[:,:,m*(i-1)+j]=A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2)+Sec;
                        Mat[:,:,m*(i-1)+j]=diagm(vec(δ_tilde))^(1/2)*(Γ*diagm(vec(κ4[m*(i-1)+j,:]))*Γ+Γ*Mg'*Qtilde0*V[:,:,m*(i-1)+j]*Qtilde0*Mg*Γ)*diagm(vec(δ_tilde))^(1/2);
                        σ_th[m*(i-1)+j]=Ygotique0'*Mat[:,:,m*(i-1)+j]*Ygotique0;
                        # Mg4=A^(1/2)*M0*diagm(sqrt.(vec(c./(co*(ones(m*k,1)+δe)))));
                        # Mg2=sum(kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,i]*e_ij[:,m*(i-1)+j]',sqrt(δ_tilde[m*(i-1)+j])*M[:,m*(i-1)+j]) for i=1:k,j=1:m)
                        # Mg3=sum(kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,i]*((c[m*(i-1)+2]/cc[i])*sqrt(δ_tilde1[i])*e_ij[:,m*(i-1)+1]'-(c[m*(i-1)+1]/cc[i])*sqrt(δ_tilde1[i])*e_ij[:,m*(i-1)+2]'),
                        # Δ2[:,i]) for i=1:k)
                        # Mg_t=sum(kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,i]*h[i]',Δ2[:,i]) for i=1:k)
                        # Qtilde01=kron(inv(Matrix{Float64}(I, k, k)+(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*diagm(vec(δ_tilde1))*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)),Matrix{Float64}(I, p, p))
                        # test=Mg'*Qtilde0*V[:,:,m*(i-1)+j]*Qtilde0*Mg
                        # KAPPAf=Dt*test2/(Matrix{Float64}(I, k, k)-Dt*test2)
                        # test1=sum(kron(sqrt(δ_tilde1[ip])*h[ip]*e_i[:,ip]'*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*inv(Matrix{Float64}(I, k, k)+(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*diagm(vec(δ_tilde1))*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2))*
                        # (diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*(e_i[:,i]*e_i[:,i]'+LUM3[i]*e_i[:,i]*e_i[:,i]')*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*inv(Matrix{Float64}(I, k, k)+(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*diagm(vec(δ_tilde1))*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2))*
                        # (diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,jp]*h[jp]'*sqrt(δ_tilde1[jp]),Δμ[ip,jp]) for ip=1:k,jp=1:k)
                end
        end
        # for i=1:k
        #         V[:,:,i]=diagm(vec(kron(κ[i,:],ones(k,1))))+kron(Agotique*((1/δ_tilde1[i])*diagm(vec(e_i[:,i]*(1+LUM3[i]))))*Agotique,ones(k,1)*ones(1,k)).*MM;
        #         σ_th[i]=Ygotique0'*diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,i]*Γ)*diagm(vec(δ_tilde))^(1/2)*Ygotique0;
        # end
        ##################TO DELET###################################
        #############################################
        #Calcul de l'erreur empirique et théorique
        threshold=sqrt(2)*erfcinv(2*eta);
        threshold2=-sqrt(σ_th[3])*threshold+μ_th[3];
        pred_source=zeros(size(X_test)[2],1);pred_target=zeros(sum(n_test[3:4]),1);
        threshold_emp=(mean(gx_s[1:n_test[1]])+mean(gx_s[1+n_test[1]:end]))/2;
        pred_source[gx_s.<threshold_emp*ones(size(X_test)[2],1)].=-1;pred_source[gx_s.>threshold_emp*ones(size(X_test)[2],1)].=1;
        threshold_emp_target=(mean(gx_t[1:n_test[3]])+mean(gx_t[1+n_test[3]:end]))/2;
        pred_target[gx_t.<threshold2*ones(sum(n_test[3:4]),1)].=-1;pred_target[gx_t.>threshold2*ones(sum(n_test[3:4]),1)].=1;
        error_source_emp=sum(pred_source.!=y_test)./size(X_test)[2];
        error_target_emp=zeros(2,1);
        error_target_th=zeros(2,1);
        error_target_emp[1]=sum(pred_target[1:n_test[3]].!=y_test1[1:n_test[3]])./sum(n_test[3]);
        error_target_emp[2]=sum(pred_target[n_test[3]+1:end].!=y_test1[n_test[3]+1:end])./sum(n_test[4]);
        error_source_th=(n_test[1]/size(X_test)[2])*0.5*erfc((μ_th[1]-μ_th[2])./(2*sqrt(2)*sqrt(σ_th[1])))+(n_test[2]/size(X_test)[2])*0.5*erfc((μ_th[1]-μ_th[2])./(2*sqrt(2)*sqrt(σ_th[1])));
        error_target_th[1]=1-0.5*erfc((threshold2-μ_th[3])./(sqrt(2)*sqrt(σ_th[3])))
        error_target_th[2]=0.5*erfc((threshold2-μ_th[4])./(sqrt(2)*sqrt(σ_th[4])));
        # A faire l'optimization par rapport à y.
        Ze=zeros(m*k,m*k);task=1;
        rg_k=1+m*(task-1):2+m*(task-1);
        Ze[rg_k,rg_k]=[(1-ns[m*(task-1)+1]/n1) -ns[m*(task-1)+2]/n1;-ns[m*(task-1)+1]/n1 (1-ns[m*(task-1)+2]/n1)];
        rg_t=1+m*(k-1):2+m*(k-1);
        Ze[rg_t,rg_t]=[(1-ns[m*(k-1)+1]/n2) -ns[m*(k-1)+2]/n2; (-ns[m*(k-1)+1]/n2) (1-ns[m*(k-1)+2]/n2)];
        #y_tilde_opt0=diagm(vec(δ_tilde))^(-1/2)*inv(Γ)*inv(V[:,:,2])*(kron(Agotique,ones(k,1)*ones(1,k)).*MM)*diagm(vec(δ_tilde))^(-1/2)*(e_ij[:,3]-e_ij[:,4]);
        # res = optimize(x->(-(x'*(Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2))*(e_ij[:,3]-e_ij[:,4]))^2/
        # (8*x'*diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,2]*Γ)*diagm(vec(δ_tilde))^(1/2)*x)), Ze*[1.0;-1.0;1.0;-1.0])
        #y_tilde_opt0=Optim.minimizer(res);
        # y_tilde_opt0=inv(diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,2]*Γ)*diagm(vec(δ_tilde))^(1/2))*
        # (Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(1/2)*Γ*diagm(vec(δ_tilde))^(-1/2))*(e_ij[:,3]-e_ij[:,4])
        #Matm=(Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2))*(e_ij[:,3]-e_ij[:,4])
        res =optimize(x->(-(-threshold*sqrt(x'*Mat[:,:,3]*x)+x'*Matm)./sqrt(x'*Mat[:,:,4]*x)), Ze*[1.0;-1.0;1.0;-1.0]);
        y_tilde_opt0=Optim.minimizer(res);
        x0=Ze*[1.0;-1.0;1.0;-1.0];
        #println(0.5*erfc(((-threshold*sqrt(x0'*Mat[:,:,3]*x0)+x0'*Matm)./sqrt(2*x0'*Mat[:,:,4]*x0))))
        #println(0.5*erfc(((threshold2-μ_th[4])./(sqrt(2)*sqrt(σ_th[4])))))
        # println(σ_th[3])
        # println(x0'*Mat[:,:,3]*x0)
        # println(μ_th[3]-μ_th[4])
        # println(x0'*Matm)
        # println(0.5*erfc(((-sqrt(x0'*Mat[:,:,3]*x0)*threshold+x0'*Matm)./(sqrt(2)*sqrt(x0'*Mat[:,:,4]*x0)))))
        # println(error_target_th[2])
        #println(0.5*erfc(((-threshold*sqrt(y_tilde_opt0'*Mat[:,:,3]*y_tilde_opt0)+y_tilde_opt0'*Matm)./sqrt(2*y_tilde_opt0'*Mat[:,:,4]*y_tilde_opt0))))
        # x1=Ze*[1.0;-1.0;1.0;-1.0];
        # x2=y_tilde_opt0;
        # y_tilde_opt02=diagm(vec(δ_tilde))^(-1/2)*(inv(Γ)*inv(V[:,:,2])*inv(Γ))*diagm(vec(δ_tilde))^(-1/2)*
        # (Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2))*(e_ij[:,3]-e_ij[:,4])
        # err2=0.5*erfc(sqrt(-res(y_tilde_opt01)));
        # err=0.5*erfc(sqrt(-Optim.minimum(res)));
        y_tilde_opt=pinv(Ze)*y_tilde_opt0;
        #y_tilde_opt=Ze\y_tilde_opt0;
        y_tilde_opt0=Ze*y_tilde_opt;
        #println(0.5*erfc(((-sqrt(y_tilde_opt0'*Mat[:,:,3]*y_tilde_opt0)*threshold+y_tilde_opt0'*Matm)./(sqrt(2)*sqrt(y_tilde_opt0'*Mat[:,:,4]*y_tilde_opt0)))))
        # optim1=(x1'*(Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2))*(e_ij[:,3]-e_ij[:,4]))^2/(8*x1'*diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,2]*Γ)*diagm(vec(δ_tilde))^(1/2)*x1)
        # optim2=(x2'*(Matrix{Float64}(I, k*m, k*m)-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2))*(e_ij[:,3]-e_ij[:,4]))^2/(8*x2'*diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,2]*Γ)*diagm(vec(δ_tilde))^(1/2)*x2)
        #y_tilde_opt=pinv(Ze,rtol=1e-12)*y_tilde_opt0;

        #Calcul empirique
        y_opt=J*y_tilde_opt;
        ##################################
        S1=zeros(k*p,k*p,m*k);
        d=zeros(k*m,1);
        Tbar=zeros(m*k,m*k);
        Tg=zeros(m*k,m*k);
        σ_th1=zeros(m*k,1);
        # for i=1:k
        #         e_i=zeros(k,1);e_i[i]=1;
        #         for j=1:m
        #                 S1[:,:,m*(i-1)+j]=kron(e_i*e_i',Σ[:,:,m*(i-1)+j]);
        #                 d[m*(i-1)+j]=ns[m*(i-1)+j]./(k*p*(1+δe[m*(i-1)+j])^2)
        #                 for ip=1:k
        #                         for jp=1:m
        #                                 Tbar[m*(i-1)+j,m*(ip-1)+jp]=(1/(k*p))*tr(C[:,:,m*(ip-1)+jp]*Qbar*A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2)*Qbar);
        #                                 Tg[m*(i-1)+j,m*(ip-1)+jp]=(1/(k*p))*tr(C[:,:,m*(i-1)+j]*Qbar*C[:,:,m*(ip-1)+jp]*Qbar);
        #                         end
        #                 end
        #         end
        # end
        # D=diagm(vec(d));
        # T=Tbar/(Matrix{Float64}(I, m*k, m*k)-D*Tg);
        # κ4=zeros(k*m,k*m);
        # V=zeros(k*p,k*p,m*k);
        # for i=1:k
        #         for j=1:m
        #                 for ip=1:k
        #                         for jp=1:m
        #                                 κ4[m*(i-1)+j,m*(ip-1)+jp]=d[m*(ip-1)+jp]*T[m*(i-1)+j,m*(ip-1)+jp]/δ_tilde[m*(ip-1)+jp];
        #                         end
        #                 end
        #                 # LUM=(Tbar/(Matrix{Float64}(I, m*k, m*k)-D*Tg))*D;
        #                 # LUM_test=(test2/(Matrix{Float64}(I, k, k)-Dt*test2))*Dt
        #                 # LUM2=[LUM[1,1]+LUM[1,2] LUM[1,3]+LUM[1,4];LUM[3,1]+LUM[3,2] LUM[3,3]+LUM[3,4]];
        #                 # LUM3=[LUM2[1,1]+LUM2[1,2];LUM2[2,1]+LUM2[2,2]];
        #                 Sec=sum(δ_tilde[m*(ip-1)+jp]*κ4[m*(i-1)+j,m*(ip-1)+jp]*A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2) for ip=1:k,jp=1:m);
        #                 # Sec2=LUM3[i]*A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2);
        #                 # Ve=kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*(e_i[:,i]*e_i[:,i]'+e_i[:,i]*e_i[:,i]'*LUM3[i])*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2),Matrix{Float64}(I, p, p))
        #                 V[:,:,m*(i-1)+j]=A^(1/2)*S1[:,:,m*(i-1)+j]*A^(1/2)+Sec;
        #                 σ_th1[m*(i-1)+j]=y_tilde_opt0'*diagm(vec(δ_tilde))^(1/2)*(Γ*diagm(vec(κ4[m*(i-1)+j,:]))*Γ+Γ*Mg'*Qtilde0*V[:,:,m*(i-1)+j]*Qtilde0*Mg*Γ)*diagm(vec(δ_tilde))^(1/2)*y_tilde_opt0;
        #                 # Mg4=A^(1/2)*M0*diagm(sqrt.(vec(c./(co*(ones(m*k,1)+δe)))));
        #                 # Mg2=sum(kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,i]*e_ij[:,m*(i-1)+j]',sqrt(δ_tilde[m*(i-1)+j])*M[:,m*(i-1)+j]) for i=1:k,j=1:m)
        #                 # Mg3=sum(kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,i]*((c[m*(i-1)+2]/cc[i])*sqrt(δ_tilde1[i])*e_ij[:,m*(i-1)+1]'-(c[m*(i-1)+1]/cc[i])*sqrt(δ_tilde1[i])*e_ij[:,m*(i-1)+2]'),
        #                 # Δ2[:,i]) for i=1:k)
        #                 # Mg_t=sum(kron((diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,i]*h[i]',Δ2[:,i]) for i=1:k)
        #                 # Qtilde01=kron(inv(Matrix{Float64}(I, k, k)+(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*diagm(vec(δ_tilde1))*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)),Matrix{Float64}(I, p, p))
        #                 # test=Mg'*Qtilde0*V[:,:,m*(i-1)+j]*Qtilde0*Mg
        #                 # KAPPAf=Dt*test2/(Matrix{Float64}(I, k, k)-Dt*test2)
        #                 # test1=sum(kron(sqrt(δ_tilde1[ip])*h[ip]*e_i[:,ip]'*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*inv(Matrix{Float64}(I, k, k)+(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*diagm(vec(δ_tilde1))*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2))*
        #                 # (diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*(e_i[:,i]*e_i[:,i]'+LUM3[i]*e_i[:,i]*e_i[:,i]')*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*inv(Matrix{Float64}(I, k, k)+(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*diagm(vec(δ_tilde1))*(diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2))*
        #                 # (diagm(γ)+λ*ones(k,1)*ones(1,k))^(1/2)*e_i[:,jp]*h[jp]'*sqrt(δ_tilde1[jp]),Δμ[ip,jp]) for ip=1:k,jp=1:k)
        #         end
        # end
        #######################
        b_opt=(P'*Q*P)\(P'*Q*y_opt);
        gx_s_opt=(1/(k*p))*kron(e_s,X_test)'*A*Z*Q*(y_opt-P*b_opt)+b_opt[1]*ones(size(X_test)[2],1);
        gx_t_opt=(1/(k*p))*kron(e_t,X_test1)'*A*Z*Q*(y_opt-P*b_opt)+b_opt[2]*ones(sum(n_test[3:4]),1);
        # gx_t_opt2=(1/(k*p))*kron(e_t,X_test1)'*A^(1/2)*Qtilde*A^(1/2)*Z*(y_opt-P*b_opt)+b_opt[2]*ones(sum(n_test[3:4]),1);
        # Qtilde=inv((1/(k*p))*A^(1/2)*Z*Z'*A^(1/2)+Matrix{Float64}(I, k*p, k*p));
        #  gx_t2_opt=(1/(k*p))*kron(e_t,X_test1)'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)+b_opt[2]*ones(sum(n_test[3:4]),1);
        #  gx_t22_opt=(1/(k*p))*kron(e_t,X_test1)'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)+b_opt[2]*ones(sum(n_test[3:4]),1);
        #  gx_t2221_opt=(1/(k*p))*kron(e_t,mean(X_test1[:,1:n_test[1]],dims=2))'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)+[b_opt[2]];
        #  gx_t222_opt=(1/(k*p))*M0'*A^(1/2)*Qbar*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)+[b_opt[1];b_opt[1];b_opt[2];b_opt[2]];
        #  gx_t222_opt=(1/(k*p))*M0'*A^(1/2)*(Qtilde0)*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)-
        #  (1/(k*p))*M0'*A^(1/2)*(Qtilde0*Mg*inv(Matrix{Float64}(I, k*m, k*m)+Mg'*Qtilde0*Mg)*Mg'*Qtilde0)*A^(1/2)*M_δ*J'*(y_opt-P*b_opt)+[b_opt[1];b_opt[1];b_opt[2];b_opt[2]];
        #  gth=Ygotique_opt-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2)*Ygotique0_opt;
        μ_emp_opt=zeros(m*k,1);
        σ_emp_opt=zeros(m*k,1);
        σ_th_opt=zeros(k,1);
        μ_emp_opt[1]=mean(gx_s_opt[1:n_test[1]]);
        μ_emp_opt[2]=mean(gx_s_opt[1+n_test[1]:n_test[1]+n_test[2]]);
        μ_emp_opt[3]=mean(gx_t_opt[1:n_test[3]]);
        μ_emp_opt[4]=mean(gx_t_opt[n_test[3]+1:n_test[3]+n_test[4]]);
        σ_emp_opt[1]=std(gx_s_opt[1:n_test[1]]).^2;
        σ_emp_opt[2]=std(gx_s_opt[1+n_test[1]:n_test[1]+n_test[2]]).^2;
        σ_emp_opt[3]=std(gx_t_opt[1:n_test[3]]).^2;
        σ_emp_opt[4]=std(gx_t_opt[n_test[3]+1:end]).^2;
        #Calcul théorique des erreurs
        Ygotique_opt=y_tilde_opt;Ygotique0_opt=y_tilde_opt0;
        μ_th_opt=Ygotique_opt-diagm(vec(δ_tilde))^(-1/2)*Γ*diagm(vec(δ_tilde))^(1/2)*Ygotique0_opt;
        σ_th_opt=zeros(m*k,1);
        #V=zeros(k*m,k*m,k)
        for i=1:k
                for j=1:m
                # V[:,:,i]=diagm(vec(kron(κ[i,:],ones(k,1))))+kron(Agotique*((1/δ_tilde1[i])*diagm(vec(e_i[:,i]*(1+LUM3[i]))))*Agotique,ones(k,1)*ones(1,k)).*MM;
                        σ_th_opt[m*(i-1)+j]=Ygotique0_opt'*Mat[:,:,m*(i-1)+j]*Ygotique0_opt;
                end
        end
        threshold_opt=sqrt(2)*erfcinv(2*eta);
        threshold2_opt=-sqrt(σ_th_opt[3])*threshold_opt+μ_th_opt[3];
        #Calcul empirique error
        pred_source_opt=zeros(size(X_test)[2],1);pred_target_opt=zeros(sum(n_test[3:4]),1);
        threshold_emp_opt=(mean(gx_s_opt[1:n_test[1]])+mean(gx_s_opt[1+n_test[1]:end]))/2;
        pred_source_opt[gx_s_opt.<threshold_emp_opt*ones(size(X_test)[2],1)].=-1;pred_source_opt[gx_s_opt.>threshold_emp_opt*ones(size(X_test)[2],1)].=1;
        threshold_emp_target_opt=(mean(gx_t_opt[1:n_test[3]])+mean(gx_t_opt[1+n_test[3]:end]))/2;
        pred_target_opt[gx_t_opt.<threshold2_opt*ones(sum(n_test[3:4]),1)].=-1;pred_target_opt[gx_t_opt.>threshold2_opt*ones(sum(n_test[3:4]),1)].=1;
        error_source_emp_opt=sum(pred_source_opt.!=y_test)./size(X_test)[2];
        error_target_emp_opt=zeros(2,1);
        error_target_th_opt=zeros(2,1);
        error_target_emp_opt[1]=sum(pred_target_opt[1:n_test[3]].!=y_test1[1:n_test[3]])./sum(n_test[3]);
        error_target_emp_opt[2]=sum(pred_target_opt[n_test[3]+1:end].!=y_test1[n_test[3]+1:end])./sum(n_test[4]);
        # for i=1:k
        #         V[:,:,i]=diagm(vec(kron(κ[i,:],ones(k,1))))+kron(Agotique*((1/δ_tilde1[i])*diagm(vec(e_i[:,i]*(1+LUM3[i]))))*Agotique,ones(k,1)*ones(1,k)).*MM;
        #         σ_th_opt[i]=Ygotique0_opt'*diagm(vec(δ_tilde))^(1/2)*(Γ*V[:,:,i]*Γ)*diagm(vec(δ_tilde))^(1/2)*Ygotique0_opt;
        # end
        error_source_th_opt=(n_test[1]/size(X_test)[2])*0.5*erfc((μ_th_opt[1]-μ_th_opt[2])./(2*sqrt(2)*sqrt(σ_th_opt[1])))+(n_test[2]/size(X_test)[2])*0.5*erfc((μ_th_opt[1]-μ_th_opt[2])./(2*sqrt(2)*sqrt(σ_th_opt[1])));
        error_target_th_opt[1]=1-0.5*erfc((threshold2_opt-μ_th_opt[3])./(sqrt(2)*sqrt(σ_th_opt[3])));
        error_target_th_opt[2]=0.5*erfc((threshold2_opt-μ_th_opt[4])./(sqrt(2)*sqrt(σ_th_opt[4])));
        # println(0.5*erfc((-sqrt(σ_th_opt[3])*threshold+μ_th_opt[3]-μ_th_opt[4])./(sqrt(2)*sqrt(σ_th_opt[4]))));
        # println(0.5*erfc(((-sqrt(y_tilde_opt0'*Mat[:,:,3]*y_tilde_opt0)*threshold+y_tilde_opt0'*Matm)./(sqrt(2)*sqrt(y_tilde_opt0'*Mat[:,:,4]*y_tilde_opt0)))))
        # println(error_target_th_opt[2])
        # println(error_target_th)
        # println(error_target_emp)
        # println(0.5*erfc((threshold2_opt-μ_th_opt[4])./(sqrt(2)*sqrt(σ_th_opt[4]))))
        # println(0.5*erfc((threshold2_opt-μ_emp_opt[4])./(sqrt(2)*sqrt(σ_emp_opt[4]))))
        # println(μ_th)
        # println(μ_emp)
        # println(σ_th)
        # println(σ_emp)
        p1=histogram(gx_s[n_test[1]+1:end],normalize = true,alpha=0.5,bins=100);
        p1=histogram!(gx_s[1:n_test[1]],normalize = true,alpha=0.5,bins=100);
        p1=plot!(Normal(μ_th[1],sqrt(abs(σ_th[1]))));
        p1=plot!(Normal(μ_th[2],sqrt(abs(σ_th[1]))));
        display(p1)
        p2=histogram(gx_t[n_test[3]+1:end],normalize = true,alpha=0.5,bins=100);
        p2=histogram!(gx_t[1:n_test[3]],normalize = true,alpha=0.5,bins=100);
        p2=plot!(Normal(μ_th[3],sqrt(abs(σ_th[3]))));
        p2=plot!(Normal(μ_th[4],sqrt(abs(σ_th[3]))));
        p2=plot!([threshold2,threshold2],[0,0.6]);
        display(p2)
        p3=histogram(gx_s_opt[n_test[1]+1:end],normalize = true,alpha=0.5,bins=100);
        p3=histogram!(gx_s_opt[1:n_test[1]],normalize = true,alpha=0.5,bins=100);
        p3=plot!(Normal(μ_th_opt[1],sqrt(abs(σ_th_opt[1]))));
        p3=plot!(Normal(μ_th_opt[2],sqrt(abs(σ_th_opt[1]))));
        display(p3)
        p4=histogram(gx_t_opt[n_test[3]+1:end],normalize = true,alpha=0.5,bins=100);
        p4=histogram!(gx_t_opt[1:n_test[3]],normalize = true,alpha=0.5,bins=100);
        p4=plot!(Normal(μ_th_opt[3],sqrt(abs(σ_th_opt[3]))));
        p4=plot!(Normal(μ_th_opt[4],sqrt(abs(σ_th_opt[3]))));
        p4=plot!([threshold2_opt,threshold2_opt],[0,0.6]);
        display(p4)
        return gx_s,gx_t,μ_th,μ_emp,σ_th,σ_emp,error_source_emp,error_target_emp,error_source_th,error_target_th,
        gx_s_opt,gx_t_opt,μ_th_opt,μ_emp_opt,σ_th_opt,σ_emp_opt,error_source_emp_opt,error_target_emp_opt,error_source_th_opt,error_target_th_opt
end

function compute_statistics(Sfts,Tfts,ns)
        M=zeros(p,4);
        Σ=zeros(p,p,4);
        M[:,1]=mean(Sfts[:,1:ns[1]],dims=2);
        M[:,2]=mean(Sfts[:,ns[1]+1:end],dims=2);
        M[:,3]=mean(Tfts[:,1:ns[3]],dims=2);
        M[:,4]=mean(Tfts[:,ns[3]+1:end],dims=2);
        Σ[:,:,1]=(Sfts[:,1:ns[1]]-M[:,1]*ones(1,ns[1]))*(Sfts[:,1:ns[1]]-M[:,1]*ones(1,ns[1]))'./ns[1];
        Σ[:,:,2]=(Sfts[:,ns[1]+1:end]-M[:,2]*ones(1,ns[2]))*(Sfts[:,ns[1]+1:end]-M[:,2]*ones(1,ns[2]))'./ns[2];
        Σ[:,:,3]=(Tfts[:,1:ns[3]]-M[:,3]*ones(1,ns[3]))*(Tfts[:,1:ns[3]]-M[:,3]*ones(1,ns[3]))'./ns[3];
        Σ[:,:,4]=(Tfts[:,ns[3]+1:end]-M[:,4]*ones(1,ns[4]))*(Tfts[:,ns[3]+1:end]-M[:,4]*ones(1,ns[4]))'./ns[4];
    return M,Σ
end
function delta_function(C,k,m,p,ns,λ,γ)
        c=ns/sum(ns);
        co=k*p/sum(ns);
        δ_1=rand(m*k,1);δ_2=rand(m*k,1);
        ϵ=1e-6;
        n_iter=0;
        while ((abs(δ_1[1]-δ_2[1])>ϵ) || (abs(δ_1[2]-δ_2[2])>ϵ) || (abs(δ_1[3]-δ_2[3])>ϵ) || (abs(δ_1[4]-δ_2[4])>ϵ))
                n_iter=n_iter+1
                #println(n_iter)
                δ_1=δ_2;
                #invQ=zeros(k*p,k*p);
                invQ=sum((c[m*(i-1)+j]/co)*C[:,:,m*(i-1)+j]./(1+δ_1[m*(i-1)+j]) for i=1:k,j=1:m)+Matrix{Float64}(I, k*p, k*p);
                #invQ=invQ;
                δ_2=zeros(m*k,1);
                for i=1:k
                        for j=1:m
                                δ_2[m*(i-1)+j]=(1/(k*p))*tr(C[:,:,m*(i-1)+j]*inv(invQ));
                        end
                end
                #println(δ_1-δ_2)
        end
        invQ=sum((c[m*(i-1)+j]/co)*C[:,:,m*(i-1)+j]./(1+δ_2[m*(i-1)+j]) for i=1:k,j=1:m)+Matrix{Float64}(I, k*p, k*p);
        δ=δ_2;Qbar=inv(invQ);
        return δ,Qbar
end
function delta_function_identity(k,p,ns,λ,γ)
        c=ns/sum(ns);
        co=k*p/sum(ns);
        δ_1=rand(k,1);δ_2=rand(k,1);
        ϵ=1e-6;
        n_iter=0;
        while ((abs(δ_1[1]-δ_2[1])>ϵ) || (abs(δ_1[2]-δ_2[2])>ϵ))
                n_iter=n_iter+1
                #println(n_iter)
                δ_1=δ_2;
                c11=c[2*(1-1)+1];c12=c[2*(1-1)+2];c21=c[2*(2-1)+1];c22=c[2*(2-1)+2];
                c1=c11+c12;c2=c21+c22;
                δ_tilde1=zeros(k,1);
                δ_tilde1[1]=c1/(co*(1+δ_1[1]));δ_tilde1[2]=c2/(co*(1+δ_1[2]));
                Agotique=(1/k)*inv(diagm(vec(δ_tilde1))+inv(diagm(γ)+λ*ones(k,1)*ones(1,k)));
                δ_2=zeros(k,1);
                δ_2[1]=Agotique[1,1];
                δ_2[2]=Agotique[2,2];
                #println(δ_1-δ_2)
        end
        δ=δ_2;
        return δ
end
